*	MONTST.ASM

	TTL 'Monitor Test Patterns'

*	Jed Margolin
*  	3/26/86

	XREF VJ_CHATCH,VJ_BADJ,VJ_RSUB1,VJ_RSUB2,VJ_LINTST,VJ_ZTEST,VJ_PTEST
	XREF VJ_MSG1,VJ_MSG2,VJ_MSG3,VJ_MSG4,VJ_MSG5,VJ_MSG6,VJ_MSG7,VJ_MSG8
	XREF VJ_MSG9,VJ_MSG10,VJ_MSG11,VJ_MSG12,VJ_MSG13,VJ_MSG14
	XREF VJ_IMSG1,VJ_IMSG2,VJ_IMSG3,VJ_IMSG4
	XREF VGIMAGE,VGANLOC,IMAGE2,VGLOC2,VJ_BKBOX,VJ_LTEST
	XREF VJ_VGAN,VJ_CRSR,VJ_DLINE,VJ_HVRAS,VJ_BBOX,VJ_ARROWS
	XREF IM1LEN,IM2LEN,GO,VW_2D

	INCLUDE 'COMN.ASM'

LTHSW	EQU	FX1	* Re-use it for Test Program - [4 bytes each]
RTHSW	EQU	FY1	* Byte 0,1 = Switch Input Shifter
LFSW	EQU	FZ1	* Byte 2 = Debounced, 0 = on, FFFF=off
RFSW	EQU	VX1	* Byte 3 = zero crossing detected = 1
ZSCALE	EQU	VY1	* Z Scale Brightness
HVCNTR	EQU	VY1+2	* Timer for HV Test
YOFF	EQU	VZ1	* Y offset
SFLAG	EQU	VZ1+2	* Flag .NEZ. indicates that a test has been selected

	SECTION	PROGRAM

	XDEF	MONSTER,LINEWID,LINEHT,NLINES,DEFCLR,SCLR,CKTBL,IMSGTBL
	XDEF	MTINIT,PSA,CINSTR,SWRIN,SWROUT,MSUB1,TST13,TST14

RED	EQU	4
GREEN	EQU	2
BLUE	EQU	1
WHITE	EQU	7
PURPLE	EQU	5
YELLOW	EQU	6
*===============================================================================
	PAGE
* Message Targets
LINEWID DC.W	24*10			* Line Width	
LINEHT	DC.W	24+1			* Height of Line
DEFCLR	DC.B	BLUE			* Default Color 
SCLR	DC.B	RED			* Color of Selected message

*		X Pos, Y Pos, Msg, Routine

CKTBL:	
	DC.W	-384,300,VJ_MSG11		* SIZE, CENTER
	DC.L	TST11

	DC.W	-384,250,VJ_MSG8		* INTEGRATOR ADJUST
	DC.L	TST8

	DC.W	-384,200,VJ_MSG2		* BIP ADJUST
	DC.L	TST2

	DC.W	-384,150,VJ_MSG4		* LINEARITY
	DC.L	TST4

	DC.W	-384,100,VJ_MSG7		* LINEAR SCALING
	DC.L	TST7

	DC.W	-384,50,VJ_MSG12		* DISPLAY OBJECT
	DC.L	TST12

	DC.W	-384,0,VJ_MSG13			* SET CLOCK
	DC.L	TST13

	DC.W	50,300,VJ_MSG6			* POTS
	DC.L	TST6

	DC.W	50,250,VJ_MSG1			* CROSS HATCH
	DC.L	TST1

	DC.W	50,200,VJ_MSG9			* DOTS
	DC.L	TST9

	DC.W	50,150,VJ_MSG3			* RASTER
	DC.L	TST3

	DC.W	50,100,VJ_MSG5			* INTENSITY
	DC.L	TST5

	DC.W	50,50,VJ_MSG10			* HV TEST
	DC.L	TST10

	DC.W	50,0,VJ_MSG14			* TEST
	DC.L	TST14

NLINES	DC.W	(NLINES-CKTBL)/10	* Number of lines
*===============================================================================
* INSTRUCTION MESSAGE TABLE
IMSGTBL	
* 		Number of Messages
	DC.W	4			

*		Color, Y Position, Message
	DC.W	GREEN,-225,VJ_IMSG1
	DC.W	GREEN,-250,VJ_IMSG2
	DC.W	GREEN,-275,VJ_IMSG3
	DC.W	GREEN,-300,VJ_IMSG4
ILMARG	DC.W	$0FE80			* Left Margin 
*===============================================================================
	PAGE
* Test Patterns as selected by Self_Test Switch.
MONSTER:
	BSR	MTINIT			* Initialisation for Test Patterns

	BSR	CLKINIT			* Initialise the Time Clock

MONS1	BTST	#3,INPUTS		* Self Test Switch
	BEQ	MONS2
	JMP	PMESS			* Out of Self Test; Back to the Future

MONS2	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+		* Center
	MOVE.W	#$7200,(A0)+		* Scale

	MOVE.W	#VJ_BKBOX,(A0)+		* Draw Beam Killer Box

	MOVE.B	#BLUE,D0
	BSR	C3INSTR			* Generate Color Instruction

	MOVE.W	#$8040,(A0)+		* Center

*---
* Message Targets
	CLR.W	SFLAG			* 'Select' Flag
	LEA.L	CKTBL,A1
	MOVE.W	NLINES,D5

MONS3	BSR	MSUB1
	SUBQ.W	#1,D5
	BNE	MONS3	

*---
* Instruction Labels
	LEA.L	IMSGTBL,A1
	MOVE.W	(A1)+,D5		* NUMBER OF LINES TO DO

MONS4	MOVE.W	(A1)+,D0
	BSR	C3INSTR			* Color (Does not change Selected Color)

	MOVE.W	(A1)+,D0
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+		* dy

	MOVE.W	ILMARG,D0
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+		* dx

	MOVE.W	(A1)+,(A0)+		* Instruction Message
	MOVE.W	#$8040,(A0)+		* VG Center

	SUBQ.W	#1,D5
	BNE	MONS4
*---
	BSR	READCLK
	BSR	DISPCLK

* Cursor
	BSR	CURSOR
	MOVE.W	#$2000,(A0)+		* VGHALT
*---
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*

* Was the Thumb Switch pressed?
	TST.B	RTHSW+3
	BNE	MONS5		* yes
	BRA	MONS1		* no

MONS5	CLR.B	RTHSW+3		* Clear the Right Thumb Flag 

* Was a test selected?
	TST.W	SFLAG
	BEQ	MONS1		* no
* yes
	MOVE.L	MONPTR,A2
	JMP	(A2)		* (A2) is the test pattern selected

	PAGE
* MONITOR TEST PATTERN #1 - Cross hatch

TST1:	MOVEA.L	#VMEM,A0		* Initialise VG POINTER
	
	BSR	CINSTR			* Generate Color Instruction (Switch)

	MOVE.W 	#VJ_CHATCH,(A0)+	* JSRL TO CROSS HATCH PATTERN
	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*
	BRA	PCON	* Decide whether to Continue or to Return to the Menu.

*===============================================================================
* MONITOR TEST PATTERN #2 - Boxes for BIP Test

TST2	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W 	#VJ_BADJ,(A0)+		* DO BIP ADJUST
	MOVE.L	A0,VG_PTR

	MOVE.W	#15,MSGNUM
	BSR	DOMSG2

	MOVE.L	VG_PTR,A0
	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?

	BRA	PCON	* Decide whether to Continue or to Return to the Menu.
*===============================================================================
* MONITOR TEST PATTERN #3 - Raster

TST3:	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+		* Center

	MOVE.W 	#$7200,(A0)+		* Scale

	BSR	CINSTR			* Generate Color Instruction

* Y offset
	MOVE.B 	YOFF,D0			* 0 - 256
	ADD.B	#$80,D0			* -128 TO +127
	EXT.W	D0
	ASL.W	#1,D0			* -256 TO +255
	SUB.W	#$0A0,D0		* PATTERN OFFSET
	AND.W	#$1FFF,D0		* VCTR DY
	MOVE.W	D0,(A0)+

*	MOVE.W	#$1F80,(A0)+		* dy
	MOVE.W	#$1E01,(A0)+		* dx

	MOVE.W	#50,D1
	MOVE.W	#VJ_RSUB2,D0		* Raster line pair subroutine
TST3A   MOVE.W	D0,(A0)+
	DBF	D1,TST3A

	MOVE.W	#0,(A0)+		* last dy
	MOVE.W	#1023,(A0)+		* last dx

	MOVE.W	#$8040,(A0)+		* Center

* Draw a line to try to counterbalance the averaging circuit
	TST.B	RPOT0
	BPL	TST3B

	MOVE.W	#-511&$1FFF,(A0)+	* dy

	BRA	TST3C

TST3B	MOVE.W	#511&$1FFF,(A0)+	* dy

TST3C	MOVE.W	#-511&$1FFF,(A0)+	* dx

	MOVE.W	#0,(A0)+		* dy
	MOVE.W	#1024,(A0)+		* dx

	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?

	BRA	PCON	* Decide whether to Continue or to Return to the Menu.
*===============================================================================
* MONITOR TEST PATTERN #4 - Linearity 

TST4:	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+
	MOVE.W	#$7200,(A0)+

	BSR	CINSTR			* Generate Color Instruction

	MOVE.W 	#VJ_LINTST,(A0)+	* DO Linearity Test
	MOVE.L	A0,VG_PTR

	MOVE.W	#16,MSGNUM
	BSR	DOMSG2

	MOVE.W	#17,MSGNUM
	BSR	DOMSG2

	MOVE.L	VG_PTR,A0
	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?

	BRA	PCON	* Decide whether to Continue or to Return to the Menu.
*===============================================================================
* MONITOR TEST PATTERN #5 - Intensity 

TST5:	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W 	#VJ_ZTEST,(A0)+		* DO Linearity Test
	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?

	BRA	PCON	* Decide whether to Continue or to Return to the Menu.
*===============================================================================
* MONITOR TEST PATTERN #6 - Pot Test

TST6:	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+		* Center
	MOVE.W	#$7200,(A0)+		* Scale
	MOVE.W	#VJ_BKBOX,(A0)+		* Draw Beam Killer Box

	MOVE.W 	#VJ_PTEST,(A0)+		* Overlay for Pot Test

	MOVE.B	RPOT0,D0
	ADD.B	#$80,D0
	EXT.W	D0
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+		* dy

	MOVE.B	RPOT1,D0
	ADD.B	#$80,D0
	EXT.W	D0
	AND.W	#$1FFF,D0
	OR.W	#$6000,D0
	MOVE.W	D0,(A0)+		* dx

	MOVE.W	#$8040,(A0)+		* Center

	MOVE.W	#((-200)&$1FFF),(A0)+	* dy
	MOVE.W	#((-512)&$1FFF),(A0)+	* dx
	MOVE.W	#$7200,(A0)+		* Scale
	MOVE.W 	#VJ_VGAN,(A0)+		* D0 Alphanumerics
	MOVE.W	#$8040,(A0)+		* Center

	MOVE.W	#((200)&$1FFF),(A0)+	* dy
	MOVE.W	#((-304)&$1FFF),(A0)+	* dx
	MOVE.W	#$7300,(A0)+		* Scale
	MOVE.W 	#VJ_VGAN,(A0)+		* D0 Alphanumerics
	MOVE.W	#$8040,(A0)+		* Center

	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?

	BRA	PCON	* Decide whether to Continue or to Return to the Menu.
*===============================================================================
* MONITOR TEST PATTERN #7 - LINEAR SCALING TEST

TST7:	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+

	MOVE.W	#VJ_BKBOX,(A0)+		* Draw Beam Killer Box

	MOVE.W	#$8040,(A0)+

	MOVE.W	#$7200,D0	* UPDATED ONLY WHEN LEFT TRIGGER IS PRESSED
	MOVE.B	YOFF,D0			* LINEAR SCALING (USED AS Y OFFSET BY
	MOVE.W	D0,(A0)+		*  OTHER ROUTINES

	BSR	CINSTR			* Generate Color Instruction

	MOVE.W 	#VJ_LTEST,(A0)+		* LINEAR SCALING TEST

	MOVE.W	#$8040,(A0)+		* Center
	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?


	BRA	PCON	* Decide whether to Continue or to Return to the Menu.
*===============================================================================
* MONITOR TEST PATTERN #8 - Integrator Offset Test

TST8:	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+
	MOVE.W	#$7200,(A0)+

	BSR	CINSTR			* Generate Color Instruction

	MOVE.W	#VJ_BKBOX,(A0)+		* Draw Beam Killer Box
	MOVE.W	#$8040,(A0)+		* Center

	BSR	DBOX			* Draw a medium size box; Center
	BSR	BUSYIN			* Keep the VG Busy doing STAT
	BSR	DBOX			* Draw another Box 
	MOVE.L	A0,VG_PTR

	MOVE.W	#14,MSGNUM
	BSR	DOMSG2
	
	MOVE.L	VG_PTR,A0
	MOVE.W	#$2000,(A0)+		* VGHALT
	
TST8L	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?

	TST.B	RTHSW+3		* Right Thumb Switch?
	BEQ	TST8L		* no; This one is just going to loop

	CLR.B	RTHSW+3		* Yes. Clear the Flag and Return to the menu.
	JMP	MONS1
*------
PVCTR	MACRO	
	DC.W	\2&$1FFF,(\1&$1FFF)!(\3*$1000)
	ENDM

*	
MSBOX	DC.W	$6260		* Color, Brightness
	DC.W	$7200		* Scale
	PVCTR	100,100,0
	PVCTR	-200,0,4
	PVCTR	0,-200,4
	PVCTR	200,0,4
	PVCTR	0,200,4
	PVCTR	-100,-100,0
	DC.W	$8040	
MBX
MBXLEN	EQU	(MBX-MSBOX)/2-1

* DRAW A MEDIUM SIZE BOX
DBOX	LEA.L	MSBOX,A1
	MOVE.W	#MBXLEN,D0
DMBL	MOVE.W	(A1)+,(A0)+
	DBF	D0,DMBL
	RTS
*------
* Keep the VG Busy doing non-Vector Instructions, Like STAT (4.6 uS each)
BUSYIN
	MOVE.W	#$6000,D0	* STAT Instruction	

	MOVE.W	#3500,D1	* 3500 STATs = 16.1 mS
BMBL	MOVE.W	D0,(A0)+
	DBF	D1,BMBL

	RTS		

*** Writing a $6FFF STAT Instruction causes the Y DAC to put out its maximum
*** current during the wait time. No Difference has been noticed in the display
*** of the boxes on the screen. Therefore the LF13201s in the 'L' configuration
*** are providing excellent 'Off' isolation. Similarly, the DC crosstalk between
*** The two TL082 sections in the same package is ok. (AC crosstalk has not yet
*** been checked. 
*===============================================================================
* MONITOR TEST PATTERN #9 - Dots

TST9:	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+		* Center

	MOVE.W 	#$7200,(A0)+		* Scale

	MOVE.W	#WHITE,D0
	BTST	#0,COLOR
	BEQ	TST9B
	MOVE.W	#PURPLE,D0
TST9B	BSR	C2INSTR			* Generate Color Instruction

	MOVE.W	#13,D1

	MOVE.W	#384,D2			* Initial Y position
TST9A	
	MOVE.W	D2,D3
	AND.W	#$1FFF,D3
	MOVE.W	D3,(A0)+		* dy

	MOVE.W	#(-511&$1FFF),(A0)+	* dx

	MOVE.W	#VJ_DLINE,(A0)+		* Line of Dots
	MOVE.W	#$8040,(A0)+

	SUB.W	#64,D2
	SUBQ.W	#1,D1
	BNE	TST9A

	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?

	BRA	PCON	* Decide whether to Continue or to Return to the Menu.
*===============================================================================
* MONITOR TEST PATTERN #10 - High Voltage Regulation

TST10:	MOVEA.L	#VMEM,A0		* VG POINTER

	MOVE.W 	#$7200,(A0)+		* Scale

	MOVE.W	#$8040,(A0)+		* Center

	MOVE.B	#GREEN,D0		* Border
	BSR	C3INSTR

	MOVE.W	#(-384)&$1FFF,(A0)+	* DY
	MOVE.W	#(-511)&$1FFF,(A0)+	* DX

	MOVE.W	#VJ_BBOX,(A0)+		* Border
	MOVE.W	#$8040,(A0)+		* Center

* Is the Right Fire Switch pressed?
	TST.B	RFSW+2			* Right Trigger Switch ?
	BNE	TST10B			
* Freeze so that unfreezing causes a change
	BTST	#6,HVCNTR
	BNE	TST10A
	MOVE.B	#$3F,HVCNTR
	BRA	TST10C
TST10A 	MOVE.B	#$0FF,HVCNTR
	BRA	TST10C

TST10B	ADDQ.B	#1,HVCNTR
TST10C	BTST	#6,HVCNTR
	BNE	TST10E			* do not draw it
	MOVE.W	#$6780,D1		* Full Bright

	MOVE.W	D1,(A0)+
	
	MOVE.W	#13,D1
	MOVE.W	#$1F10,(A0)+		* dy
	MOVE.W	#$1E60,(A0)+		* dx

	MOVE.W	#50,D1
	MOVE.W	#VJ_HVRAS,D0		* HV Raster line pair subroutine
TST10D  MOVE.W	D0,(A0)+
	DBF	D1,TST10D

TST10E	MOVE.W	#$8040,(A0)+		* Center

	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?

	BRA	PCON	* Decide whether to Continue or to Return to the Menu.
*===============================================================================
* MONITOR TEST PATTERN #11 - ARROWS to Adjust Size and Center

TST11:	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+

	MOVE.W	#VJ_BKBOX,(A0)+		* Draw Beam Killer Box 

	MOVE.W	#$8040,(A0)+

	MOVE.W	#VJ_ARROWS,(A0)+	* Arrows

	MOVE.W	#$8040,(A0)+		* Center
	MOVE.L	A0,VG_PTR

	MOVE.W	#10,MSGNUM
	BSR	DOMSG2

	MOVE.W	#11,MSGNUM
	BSR	DOMSG2

	MOVE.W	#12,MSGNUM
	BSR	DOMSG2

	MOVE.W	#13,MSGNUM
	BSR	DOMSG2

	MOVE.L	VG_PTR,A0
	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?


	BRA	PCON	* Decide whether to Continue or to Return to the Menu.
*===============================================================================
	PAGE
* MONITOR TEST PATTERN #12 - Show an Object

* Look at (and rotate) individual objects

	XREF D_CUBE,D_SQ,D_TANK,D_ROC,D_AIR,D_SAU,D_BUZZ,D_HIND,D_CITY
	XREF NT_ROLL,NT_PTCH,NT_YAW,NWC_GEN,NCONCAT,NPOST,TROTATE,INITUV
	XREF CUBE,ROCKET,TANK,AIR,SAUCER,HIND

RTBL:	
	DC.L	CUBE,D_CUBE,8
	DC.B	RED,$40

	DC.L	ROCKET,D_ROC,25
	DC.B	BLUE,$40

	DC.L	TANK,D_TANK,24
	DC.B	GREEN,$40

	DC.L	AIR,D_AIR,24
	DC.B	BLUE,$40

	DC.L	SAUCER,D_SAU,17
	DC.B	GREEN,$40

	DC.L	HIND,D_HIND,54
	DC.B	RED,$40

OLEND
OBJMAX	EQU	(OLEND-RTBL)/14-1	* # of objects in the object table

	XDEF	TST12
* Rotate the Objects to see what they look like, using only the 68010
TST12:	
* Initialise Unit Vectors 
	MOVEA.W	#UV1,A0
	JSR	INITUV

	MOVEA.W	#UV2,A0
	JSR	INITUV

	MOVEA.W	#UV3,A0
	JSR	INITUV

	MOVE.W	#$0,OBJSEL		* Select Object 0 for now

* Test 12 Main Loop
T12LP	

* Convert Model Number into Table Address
	MOVE.W	OBJSEL,D0
	MULU	#14,D0		
	LEA.L	RTBL,A0
	ADDA.W	D0,A0
	MOVE.L	A0,MODEL

	BSR 	MPOTS		* Mediate the Pots

*Rotate as requested by the Pots and Switches
	JSR	TROTATE		

* Generate the Working Copy Unit Vectors for Ship 1
	MOVE.W	#UV2,A0
	MOVE.W	#UV1,A1
	JSR 	NWC_GEN		* Generate the Working Copy (Naked)

* Form Concatenation Unit Vectors
	MOVEA.W	#CCUV,A0	*Concatenate Unit Vectors
	MOVEA.W	#UV2,A2		*UV2 is the working copy (Ship)
	MOVEA.W	#UV3,A1		*UV3 is currently the identity matrix (Observer)
	JSR	NCONCAT		*Ship in A1 looks at Ship in A2 (Naked)

	MOVEA.W	#CCUV,A0	*Translate Ship
	MOVE.W	#$100,XT(A0)	
	CLR.W	YT(A0)
	CLR.W	ZT(A0)

* Transform and Project the Object
	MOVE.L	MODEL,A3	* Model Select Table Data 

	MOVEA.W #CCUV,A0	*Post Add Transform CCUV to Point Table
	MOVE.L	(A3),A1		* 0(A1) is address of Object Picture (ex. CUBE)
	MOVEA.W	#PTBL,A2	* Put Projected points in the Point Table
	MOVE.L	8(A3),D5	* Number of Points (ex. '8')
	JSR	NPOST		* Post Add and Project

* Projected points are now in PTBL
*----
* Read and Debounce the Switches
	BSR	SWRIN

* Clear Watchdog Timer
	CLR.W	WDCLR		

* Thumb Switch - Decide whether to change the object
	TST.B	LTHSW+3		* Left Thumb Switch?
	BEQ	T12A		* no; keep going

	CLR.B	LTHSW+3		* Yes. Clear the Flag and change the object
	MOVE.W	OBJSEL,D0
	ADDQ.W	#1,D0
	CMP.W	#OBJMAX,D0	* Wrap around at maximum number of objects
	BLE	T12C
	CLR.W	D0
T12C	MOVE.W	D0,OBJSEL

* Wait for Frame Sync (VG to be done)
* Wait for transition from IRQFRAME 3 to IRQFRAME 4, Then Reset IRQFRAME
T12A	CMP.B	#4,IRQFRAME
	BNE	T12A
T12B	CMP.B	#0,IRQFRAME
	BNE	T12B
	CLR.B	IRQFRAME

* Thumb Switch - Decide whether to Continue or to Return to the Menu.
	TST.B	RTHSW+3		* Right Thumb Switch?
	BEQ	FEU		* no; keep going

	CLR.B	RTHSW+3		* Yes. Clear the Flag and Return to the menu.
	JMP	MONS1
*------
* VG is ready, so fillerup

FEU	MOVEA.L	#VMEM,A0
	MOVE.W	#$8040,(A0)+		*CENTER
	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box

	MOVE.L	MODEL,A3
	MOVE.B	12(A3),COLOR
	MOVE.B	13(A3),BRITE
	MOVE.L	4(A3),A3
	MOVE.L	A0,VG_PTR		*Save the VG Pointer
	JSR	(A3)		* Drawing Routine (ex. 'D_CUBE')

	MOVE.W	#$2000,(A0)	*VG Halt Instruction

	CLR.W	VGGO		*Start VG	

* Go 'round again	

	BRA	T12LP	
*-----
* Mediate the Pots
MPOTS	MOVE.B	RPOT0,D0
	SUB.B	#$80,D0
	ASR.B	#2,D0
	MOVE.B	D0,POT0

	MOVE.B	RPOT1,D0
	NOT.B	D0
	SUB.B	#$80,D0
	ASR.B	#2,D0
	MOVE.B	D0,POT1

	RTS
*-------------------------------------------------------------------------------
* Beat the Clock

TST13:	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+

	MOVE.W	#VJ_BKBOX,(A0)+		* Draw Beam Killer Box 

	MOVE.W	#$8040,(A0)+

	BSR	READCLK
	BSR	DISPCLK

	MOVE.W	#$8040,(A0)+		* Center
	MOVE.L	A0,VG_PTR

	MOVE.W	#28,MSGNUM
	BSR	DOMSG2

	MOVE.W	#29,MSGNUM
	BSR	DOMSG2

	MOVE.W	#30,MSGNUM
	BSR	DOMSG2

	MOVE.W	#31,MSGNUM
	BSR	DOMSG2

	MOVE.W	#32,MSGNUM
	BSR	DOMSG2

	MOVE.W	#33,MSGNUM
	BSR	DOMSG2

	MOVE.W	#34,MSGNUM
	BSR	DOMSG2

	MOVE.W	#35,MSGNUM
	BSR	DOMSG2

	MOVE.W	#36,MSGNUM
	BSR	DOMSG2

	BSR	DSPCAL

	MOVE.W	#32,(A0)+			* Center Line
	MOVE.W	#((-512)&$1FFF),(A0)+

	MOVE.W	#0,(A0)+
	MOVE.W	#(1024&$1FFF)!$6000,(A0)+

	MOVE.W	#$8040,(A0)+

	BSR	MPCHK		* Check if a message is selected. If it is, draw
*								a box around it.

	MOVE.W	#$2000,(A0)+		* VGHALT
	
	BSR	PSA2			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?


	BRA	PCON	* Decide whether to Continue or to Return to the Menu.
*-------------------------------------------------------------------------------
	PAGE
* Test Program Control
PCON:
* Has the Right Thumb button been pressed? 
	TST.B	RTHSW+3		* Right Thumb Switch?
	BEQ	BR2		* no
* Yes. Clear the Flag and Return to the menu.
	CLR.B	RTHSW+3		* Clear Flag
	BRA	MONS1		
* No. Return to the start of the current routine.
BR2 	MOVE.L	MONPTR,A2
	JMP	(A2)		
*===============================================================================
MSUB1	
* Is the cursor within bounds?
* X position
	MOVE.W	XP,D0			* Cursor X Position
	MOVE.W	(A1),D1
	CMP.W	D1,D0
	BMI	DMSG			* Out of Bounds, (Default Color)
	ADD.W	LINEWID,D1
	CMP.W	D1,D0
	BPL	DMSG			* Out of Bounds, (Default Color)
*Y Position
	MOVE.W	YP,D0			* Cursor Y Position
	MOVE.W	2(A1),D1		* Lower Limit	
	CMP.W	D1,D0
	BMI	DMSG			* Below lower limit
	ADD.W	LINEHT,D1	       * Lower Limit + Line Height = Upper Limit
	CMP.W	D1,D0
	BPL	DMSG			* Abover Upper Limit
* Yes
* Draw with Selected Color
	MOVE.B	SCLR,D0		
	BSR	C3INSTR

* Save the Test Routine Address
	MOVE.L	6(A1),MONPTR

* Set the 'Select' Flag	
	MOVE.W	#1,SFLAG

* Generate the Message
	BRA	GMSG		

* Draw with Default Color
DMSG	MOVE.B	DEFCLR,D0
	BSR	C3INSTR			

* Generate the Message
GMSG	MOVE.W	2(A1),D4
	AND.W	#$1FFF,D4
	MOVE.W	D4,(A0)+		* VG dy	

	MOVE.W	(A1),D4		
	AND.W	#$1FFF,D4		
	MOVE.W	D4,(A0)+		* VG dx

	MOVE.W 	4(A1),(A0)+		* VG Do Message 
	MOVE.W	#$8040,(A0)+		* VG Center

* Point to the next line data
	ADDA	#10,A1			
	RTS
*===============================================================================
* Uses VG Pointer in A0
CURSOR:		
	MOVE.B	RPOT0,D0		* 0 - 255
	ADD.B	#$80,D0			* - 128 TO +127
	EXT.W	D0
	ASL.W	#2,D0			* INCREASE CONTROL SENSITIVITY
	MOVE.W	YP,D1
	SUB.W	D1,D0			* Smooth it out
	ASR.W	#2,D0
	ADD.W	D1,D0			* New Position
	MOVE.W	D0,YP			* SAVE IT
	AND.W	#$1FFF,D0		
	MOVE.W	D0,(A0)+		* DY
		
	MOVE.B	RPOT1,D0		* 0 - 255
	ADD.B	#$80,D0			* - 128 TO +127
	EXT.W	D0
	ASL.W	#2,D0			* INCREASE CONTROL SENSITIVITY
	MOVE.W	XP,D1
	SUB.W	D1,D0			* Smooth it out
	ASR.W	#2,D0
	ADD.W	D1,D0			* New Position

	MOVE.W	D0,XP			* SAVE IT
	AND.W	#$1FFF,D0		
	MOVE.W	D0,(A0)+		* DX

* Cursor
	MOVE.B	#GREEN,D0
	BSR	C3INSTR

	MOVE.W	#VJ_CRSR,(A0)+		* CURSOR
	MOVE.W	#$8040,(A0)+

	RTS	

	PAGE
* Initialisation for Monitor Test Routines
MTINIT:
	CLR.W	VGRES			* Reset VG

	CLR.W	SNDRESL			* Reset Sound System
	CLR.W	SNDRESH

	CLR.W	MRESL			* Reset TMS320
	CLR.W	MRESH

	CLR.W	TXBUFFH			* Link Buffer off
	CLR.W	LNKMODEL		* Master does not respond to Interrupts

* SET 'SELECT' DEFAULTS (zero)
	MOVEA.W	#RAM,A1
	MOVE.W	#16,D0
DTLP	CLR.W	(A1)+
	DBF	D0,DTLP

	MOVE.B	#$60,ZSCALE		* Initialise Brightness
	MOVE.B	#04,COLOR		* Initialise Color
	MOVE.B	#$80,YOFF

	MOVE.W	#$2000,SR		* Enable Interrupts

* DOWNLOAD VG TEST PATTERNS
	MOVE.W	#IM2LEN,D0
*	MOVE.W	#$500,D0
	MOVEA.L	#IMAGE2,A0
	MOVEA.L	#VMEM+VGLOC2,A1
DTLP1	MOVE.W	(A0)+,(A1)+		
	DBF	D0,DTLP1

* DOWNLOAD VG ALPHANUMERICS
	MOVE.W	#IM1LEN,D0
*	MOVE.W	#$500,D0
	MOVEA.L	#VGIMAGE,A0
	MOVEA.L	#VMEM+VGANLOC,A1
DTLP2	MOVE.W	(A0)+,(A1)+		
	DBF	D0,DTLP2

	RTS	
*===========================================================================
* Public Service Announcements for Monitor Test Routines
PSA:	CLR.W	VGGO			* START VG
	
* Wait for transition from IRQFRAME 3 to IRQFRAME 4, Then Reset IRQFRAME
PSALP1	CMP.B	#4,IRQFRAME
	BNE	PSALP1
PSALP2	CMP.B	#0,IRQFRAME
	BNE	PSALP2
	CLR.B	IRQFRAME
	
	CLR.W	WDCLR		* Kick the watchdog

* Read and debounce switches
	BSR	SWRIN
*------
* Right Trigger Switch - Change Color
	TST.B	RFSW+3		* Right Trigger Switch Flag?
	BEQ	PSALP4		* no
*   yes
	MOVE.B	COLOR,D0
	ADDQ.B	#1,D0
	AND.B	#$7,D0
	BNE	PSALP3
	ADDQ.B	#1,D0		* no black
PSALP3	MOVE.B	D0,COLOR
	CLR.B	RFSW+3
*------
PSALP4	
* Left Trigger Switch - Update ZSCALE and Y offset
	TST.B	LFSW+2		* Right Trigger Switch Status?
	BNE	PSALP5		* one = off 
	MOVE.B	RPOT0,YOFF
	MOVE.B	RPOT1,D0
	LSR.B	#1,D0
	MOVE.B	D0,ZSCALE
*------
PSALP5	RTS
*===========================================================================
* Public Service Announcements for Monitor Test Routines
PSA2:	CLR.W	VGGO			* START VG
	
* Wait for transition from IRQFRAME 3 to IRQFRAME 4, Then Reset IRQFRAME
QSALP1	CMP.B	#4,IRQFRAME
	BNE	QSALP1
QSALP2	CMP.B	#0,IRQFRAME
	BNE	QSALP2
	CLR.B	IRQFRAME
	
	CLR.W	WDCLR		* Kick the watchdog

* Read and debounce switches
	BSR	SWRIN
*------
	RTS
*===========================================================================
* Generates COLOR Instruction from COLOR Address
CINSTR:	
	MOVE.B	COLOR,D0
	AND.B	#$7,D0			* MASK COLOR BITS
	OR.B	#$60,D0			* STAT INSTRUCTION
	MOVE.B	D0,(A0)+
	MOVE.B	ZSCALE,(A0)+		* ZSTAT, END OF STAT
	RTS

* Generates COLOR Instruction from D0
C2INSTR:	
	AND.B	#$7,D0			* MASK COLOR BITS
	OR.B	#$60,D0			* STAT INSTRUCTION
	MOVE.B	D0,(A0)+
	MOVE.B	ZSCALE,(A0)+		* ZSTAT, END OF STAT
	RTS

* Generates COLOR Instruction from D0, fixed brightness
C3INSTR:	
	AND.B	#$7,D0			* MASK COLOR BITS
	OR.B	#$60,D0			* STAT INSTRUCTION
	MOVE.B	D0,(A0)+
	MOVE.B	#$60,(A0)+		* ZSTAT, END OF STAT
	RTS
*===========================================================================
SWRIN:	
	MOVE.B	INPUTS,D0
	LEA.L	LTHSW,A0
	MOVE.B	#7,D2		* Left Thumb
	BSR	SWROUT

	MOVE.B	INPUTS,D0
	LEA.L	RTHSW,A0
	MOVE.B	#6,D2		* Right Thumb
	BSR	SWROUT

	MOVE.B	INPUTS,D0
	LEA.L	LFSW,A0
	MOVE.B	#5,D2		* Left Trigger
	BSR	SWROUT

	MOVE.B	INPUTS,D0
	LEA.L	RFSW,A0
	MOVE.B	#4,D2		* Right Trigger
	BSR	SWROUT

	RTS

SWROUT:	
* Shift the Switch into the first byte
	MOVE.B	(A0),D4
	LSL.B	#2,D4		
	MOVE.B	D4,(A0)

	BTST	D2,D0
	BEQ	SWR1
	OR.B	#03,(A0)	* LSL had shifted zeros into Bit 0,1
SWR1	
* Is the counter all zero?
	TST.B	(A0)
	BNE	SWR3		* not all zero				
* Yes, all zero
* Was it all zero last time?
	TST.B	2(A0)
	BNE	SWR2		* no
* Yes, so don't do anything
	RTS
* We have an off to on transition
SWR2	CLR.B	2(A0)		* Remember
	MOVE.B	#$0FF,3(A0)	* Flag
	RTS

* The switch counter is not all zero
* Is it all ones?				
SWR3	CMP.B	#$0FF,(A0)
	BNE	SWR4		* no, so don't do anything

* Yes
* Was it all ones last time?
	CMP.B	#$0FF,2(A0)
	BEQ	SWR4		* Yes, so don't do anything

* No, this is an 'on' to 'off' transition (in case we want to use it 
*								for something)
* Remember
	MOVE.B	#$0FF,2(A0)

SWR4	RTS
*===========================================================================
	TTL 'Player Option Messages'
	PAGE

	XDEF	PMTBL,PMESS,POTBL
	XDEF	MSUB2,CRSOR2,PMINIT

	XREF	VJ_PMSG1,VJ_PMSG2,VJ_PMSG3,VJ_PMSG4,VJ_PMSG5,VJ_PMSG6,VJ_PMSG7
	XREF	VJ_PMSG8,VJ_PMSG9,VJ_PMSG10
	XREF 	VJ_PMSG11,VJ_PMSG12,VJ_PMSG13,VJ_PMSG14,VJ_PMSG15
	XREF 	VJ_PMSG16,VJ_PMSG17

	XREF	IM3LEN,VGLOC3,IMAGE3,VJ_CRSR2
*--------------
OPTION	MACRO
	DC.W	\1,\2,\3,\4,\5,\6
	DC.B	\7,\8
	ENDM
*===============================================================================
* Player Message Table
* 'Message', 'Color', 'X Pos', 'Y Pos'

PMTBL:	
	DC.W	VJ_PMSG8,BLUE,-116,300		* 'TOMCAT'
	DC.W	VJ_PMSG1,GREEN,-480,144		* 'GAME LINK'
	DC.W	VJ_PMSG4,GREEN,-480,48		* 'CONTROL'
	DC.W	VJ_PMSG9,YELLOW,-288,-300	* 'PLACE CURSOR OVER OPTION'
	DC.W	VJ_PMSG10,YELLOW,-208,-348	* 'AND PRESS TRIGGER'

	DC.W	VJ_PMSG11,GREEN,-480,-32	* 'AIRCRAFT:'
	DC.W	VJ_PMSG15,GREEN,-480,-112	* 'MISSION:'

PML	DC.W	(PML-PMTBL)/8		* Number of lines
*===============================================================================
* Player Option Table
* 	'Message', 'X Position', 'X Length', 'Y Position',
* 	'Variable' if selected, 'Value' -> 'Variable' if selected, 
* 	'Default Color' if not selected, 'Select Color' if selected

POTBL:	
	OPTION	VJ_PMSG2,-192,48,144,GLINK,1,BLUE,WHITE		* 'ON'
	OPTION	VJ_PMSG3,-96,72,144,GLINK,0,BLUE,WHITE		* 'OFF'

	OPTION	VJ_PMSG5,-240,144,48,CMODE,1,BLUE,WHITE		* 'MANUAL'
	OPTION	VJ_PMSG6,-32,408,48,CMODE,0,BLUE,WHITE	   * "COMPUTER ASSISTED'

	OPTION	VJ_PMSG7,-80,128,-208,STFLAG,1,RED,RED		* 'START'

	OPTION	VJ_PMSG12,-244,72,-32,CRAFT,2,BLUE,WHITE	* 'F14'
	OPTION	VJ_PMSG13,-128,168,-32,CRAFT,1,BLUE,WHITE	* 'CHOPPER'
	OPTION	VJ_PMSG14,100,240,-32,CRAFT,0,BLUE,WHITE	* 'CESSNA 150'
	
	OPTION	VJ_PMSG17,-244,125,-112,MISSION,1,BLUE,RED	* 'COMBAT'
	OPTION	VJ_PMSG16,-24,192,-112,MISSION,0,BLUE,WHITE	* 'TRAINING'

POML	DC.W	(POML-POTBL)/14			* number of entries
*===========================================================================
PMESS:	
	MOVE.L	#USTACK,A7

	BSR	PMINIT			* Initialisation for Player Messages

	CLR.L	LTHSW
	CLR.L	RTHSW
	CLR.L	LFSW
	CLR.L	RFSW

PM1	
	BTST	#3,INPUTS		* Self Test Switch
	BNE	PM2
	JMP	MONSTER			* Go To Self Test

PM2	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+		* Center
	MOVE.W	#$7200,(A0)+		* Scale

	MOVE.W	#VJ_BKBOX,(A0)+		* Draw Beam Killer Box
*===============================================================================
* Fixed Player Messages - Table begins at PMTBL
* Display  'Message' with 'Color' at 'X Pos', 'Y Pos'
	BSR	FPMSG
*===============================================================================
* Player Option Messages - Table begins at POTBL	
*  Checks cursor against boundaries 
*	If not within boundary: 
*		Draws Message with 'Default' Color
*	If within boundary:
*		Sets $0FFFF -> SFLAG
*		If either Trigger Switch has been pressed:
*			Sets 'Value' -> 'Variable'
*			Draws Message with 'Select' Color
	
	BSR	MSUB2		
*===============================================================================
	BSR	CRSOR2
	MOVE.W	#$2000,(A0)+		* VGHALT
*-------
* Public Service 
	CLR.W	VGGO			* START VG
	
* Wait for transition from IRQFRAME 3 to IRQFRAME 4, Then Reset IRQFRAME
PM3	CMP.B	#4,IRQFRAME
	BNE	PM3
PM4	CMP.B	#0,IRQFRAME
	BNE	PM4
	CLR.B	IRQFRAME
	
	CLR.W	WDCLR		* Kick the watchdog

* Read and debounce switches
	BSR	SWRIN
*------
	TST.W	STFLAG
	BEQ	PM1		* Not Start

	CLR.W	STFLAG		* We have a GO
	JMP	GO
*===============================================================================
	PAGE
* Fixed Player Messages
FPMSG	LEA.L	PMTBL,A1
	MOVE.W	PML,D5			* Number of Messages to do

FPMSG1	MOVE.W	2(A1),D0
	BSR	C3INSTR			* Color (Does not change Selected Color)

	MOVE.W	6(A1),D0		* Y
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+		* dy

	MOVE.W	4(A1),D0		* x
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+		* dx

	MOVE.W	(A1),(A0)+		* Instruction Message
	MOVE.W	#$8040,(A0)+		* VG Center

	ADDA.L	#8,A1
	SUBQ.W	#1,D5
	BNE	FPMSG1
	RTS
*===============================================================================
	PAGE
MSUB2	
* Player Option Messages
	LEA.L	POTBL,A1		* Initialise Table
	MOVE.W	POML,D5			* Number of entries
	CLR.W	SFLAG			* Clear the 'Selected' Flag
POM1
* Is the cursor within bounds?
* X position
	MOVE.W	XP,D0			* Cursor X Position
	MOVE.W	2(A1),D1
	CMP.W	D1,D0
	BMI	POM4			* Out of Bounds 
	ADD.W	4(A1),D1		* X length
	CMP.W	D1,D0
	BPL	POM4			* Out of Bounds 
*Y Position
	MOVE.W	YP,D0			* Cursor Y Position
	MOVE.W	6(A1),D1		* Lower Limit	
	CMP.W	D1,D0
	BMI	POM4			* Below lower limit
	ADD.W	LINEHT,D1	       * Lower Limit + Line Height = Upper Limit
	CMP.W	D1,D0
	BPL	POM4			* Abover Upper Limit
* Yes
* Set the 'Select' Flag	( Will be used to brighten the cursor)
	MOVE.W	#1,SFLAG

* Has the Trigger Switch been pressed?
	TST.B	RFSW+3			* Right Trigger?
	BNE	POM3			* yes
POM2	TST.B	LFSW+3			* Left Trigger?
	BEQ	POM4			* no (go to next one)
* yes

* Set 'Value' -> 'Variable' 
POM3	MOVEA.W	8(A1),A3		* Address of Variable (Absolute Short)
	MOVE.W	10(A1),(A3)		* 'Value' -> 'Variable' 
	BRA	PDM1			* we don't need to check any more	
* Next
POM4	ADDA.L	#14,A1
	SUBQ.W	#1,D5
	BNE	POM1

* Done

* Go around again to draw the messages
PDM1	LEA.L	POTBL,A1		* Initialise Table
	MOVE.W	POML,D5			* Number of entries

* What Color?
PDM2	MOVEA.W	8(A1),A2		* 'Variable'
	MOVE.W	(A2),D0
	MOVE.W	10(A1),D1
	CMP.W	D0,D1			* 'Value'
	BNE	PDM3

* 'Selected' Color
	MOVE.B	13(A1),D0
	BSR	C3INSTR
	BRA	PDM4

* 'Default' Color
PDM3	MOVE.B	12(A1),D0
	BSR	C3INSTR

* Generate the Message
PDM4	MOVE.W	6(A1),D4		* 'Y Position'
	AND.W	#$1FFF,D4
	MOVE.W	D4,(A0)+		* VG dy	

	MOVE.W	2(A1),D4		* 'X Position'
	AND.W	#$1FFF,D4		
	MOVE.W	D4,(A0)+		* VG dx

	MOVE.W 	(A1),(A0)+		* VG Do Message 
	MOVE.W	#$8040,(A0)+		* VG Center

	ADDA.L	#14,A1			
	SUBQ.W	#1,D5
	BNE	PDM2

* done	
	CLR.B	RFSW+3			* Clear the Switch Flags
	CLR.B	LFSW+3

	RTS
*---------------------
* Initialisation for Player Option Routines
PMINIT:
	CLR.W	VGRES			* Reset VG

	CLR.W	SNDRESL			* Reset Sound System
	CLR.W	SNDRESH

	CLR.W	MRESL			* Reset TMS320
	CLR.W	MRESH

	CLR.W	TXBUFFH			* Link Buffer off
	CLR.W	LNKMODEL		* Master does not respond to Interrupts

	MOVE.B	#$60,ZSCALE		* Initialise Brightness
	MOVE.B	#04,COLOR		* Initialise Color
	MOVE.B	#$80,YOFF

	MOVE.W	#$2000,SR		* Enable Interrupts

* DOWNLOAD PLAYER OPTION MESSAGES
	MOVE.W	#IM3LEN,D0
	MOVEA.L	#IMAGE3,A0
	MOVEA.L	#VMEM+VGLOC3,A1
DPOM1	MOVE.W	(A0)+,(A1)+		
	DBF	D0,DPOM1

* DOWNLOAD VG ALPHANUMERICS
	MOVE.W	#IM1LEN,D0
	MOVEA.L	#VGIMAGE,A0
	MOVEA.L	#VMEM+VGANLOC,A1
DPOM2	MOVE.W	(A0)+,(A1)+		
	DBF	D0,DPOM2

	RTS	

CRSOR2:		
	MOVE.B	RPOT0,D0		* 0 - 255
	ADD.B	#$80,D0			* - 128 TO +127
	EXT.W	D0
	ASL.W	#2,D0			* INCREASE CONTROL SENSITIVITY
	MOVE.W	YP,D1
	SUB.W	D1,D0			* Smooth it out
	ASR.W	#2,D0
	ADD.W	D1,D0			* New Position
	MOVE.W	D0,YP			* SAVE IT
	AND.W	#$1FFF,D0		
	MOVE.W	D0,(A0)+		* DY
		
	MOVE.B	RPOT1,D0		* 0 - 255
	ADD.B	#$80,D0			* - 128 TO +127
	EXT.W	D0
	ASL.W	#2,D0			* INCREASE CONTROL SENSITIVITY
	MOVE.W	XP,D1
	SUB.W	D1,D0			* Smooth it out
	ASR.W	#2,D0
	ADD.W	D1,D0			* New Position

	MOVE.W	D0,XP			* SAVE IT
	AND.W	#$1FFF,D0		
	MOVE.W	D0,(A0)+		* DX

* Cursor ( Change color if a Message has been selected)
	MOVE.B	#BLUE,D0
	TST.W	SFLAG
	BEQ	CRSR1
	MOVE.B	#RED,D0

CRSR1	BSR	C3INSTR

	MOVE.W	#VJ_CRSR2,(A0)+		* CURSOR
	MOVE.W	#$8040,(A0)+

	RTS	
*===============================================================================
	TTL 'Extra Stuff'
	PAGE

* SSW = 0 	None
* SSW = 1	Sphere with Random Dots
* SSW = 2	Sphere with Meridian Dots
* SSW = 3	Integrator Leakage Test
* SSW = 4	Patterns in Recognition
* SSW = 5	Test Serial Characters

SSW	SET	5
*===============================================================================
* Normal Intensity Test
	IFEQ	SSW
TST14	BRA	TST5
	ENDC
*===============================================================================
* Sphere with Random Dots?
	IFEQ	SSW-1

	TTL 'SPHERES'
	PAGE
*===============================================================================
	XDEF	SPHERE,SPTS

* Sphere with Random Dots
SPTS:	SET	128
SPHERE:

 	DC.W      -4,-238,-995    	*        0         256
 	DC.W     156,-123,1004    	*      128          78
 	DC.W    -258,187,-972    	*      126         251
 	DC.W     466,-753,513    	*      328         149
 	DC.W     285,260,948    	*       47          67
 	DC.W    -444,-10,922    	*      268          64
 	DC.W    -220,899,-436    	*      166         205
 	DC.W     164,473,-892    	*       19         299
 	DC.W     598,-186,-809    	*      107         307
 	DC.W       4,63,-1022    	*      183         266
 	DC.W    -361,38,957    		*       96         110
 	DC.W     778,641,175    	*       50           9
 	DC.W     -48,-553,-859    	*      184         302
 	DC.W     206,408,-915    	*       26         296
 	DC.W     -46,-604,-825    	*        4         233
 	DC.W     -70,-847,-570    	*      184         326
 	DC.W       4,408,938    	*      180         113
 	DC.W     215,-475,880    	*      335         120
 	DC.W     121,-753,682    	*      350         138
 	DC.W    -856,479,291    	*      119         163
 	DC.W     488,-553,709    	*      138          43
 	DC.W    -261,-545,826    	*       25         126
 	DC.W       2,995,-240    	*        0         346
 	DC.W     343,497,-826    	*      214         233
 	DC.W    -275,-587,-792    	*      205         309
 	DC.W      32,51,1022    	*       32          86
 	DC.W    -982,-132,-257    	*       82         194
 	DC.W     252,-207,970    	*      309         108
 	DC.W     738,-307,639    	*      292         141
 	DC.W       1,-131,-1015    	*      359         262
 	DC.W     -25,-994,242    	*        1         166
 	DC.W    -343,-365,-892    	*      223         299
 	DC.W      49,-347,-961    	*      171         290
 	DC.W    -784,-192,-628    	*      256         322
 	DC.W     -67,438,922    	*      351          64
 	DC.W     560,-853,-80    	*      146         355
 	DC.W     -35,244,-993    	*      351         283
 	DC.W     810,135,610    	*       80          36
 	DC.W    -528,600,-638    	*      138         218
 	DC.W     340,965,-5    		*      199         180
 	DC.W    -557,829,221    	*      146         167
 	DC.W     114,-721,-717    	*      170         315
 	DC.W    -226,-883,-465    	*      194         332
 	DC.W     371,259,-918    	*      235         243
 	DC.W    -448,357,-848    	*      128         235
 	DC.W     118,-173,-1002    	*      325         258
 	DC.W      46,-322,-970    	*      171         288
 	DC.W    -877,-249,-465    	*      254         332
 	DC.W     390,-817,-476    	*      334         207
 	DC.W    -518,-197,-860    	*      249         302
 	DC.W    -861,347,430    	*      291          24
 	DC.W     -46,163,1009    	*      344          80
 	DC.W    -496,890,-96    	*      330         354
 	DC.W    -641,-296,-740    	*      245         313
 	DC.W    -488,69,-897    	*      278         298
 	DC.W    -539,853,-166    	*      147         189
 	DC.W     -21,-6,-1023    	*       73         268
 	DC.W       5,-989,262    	*      359         165
 	DC.W     426,-930,8    		*      155           0
 	DC.W     239,781,616    	*       17          37
 	DC.W     591,-211,-808    	*      109         307
 	DC.W     441,-353,-853    	*      128         303
 	DC.W    -192,-230,979    	*       39         107
 	DC.W    -421,-93,-928    	*      257         294
 	DC.W     616,438,-690    	*       54         317
 	DC.W    -161,-588,822    	*       15         126
 	DC.W      57,-599,-827    	*      354         233
 	DC.W     604,135,815    	*      257         127
 	DC.W      75,676,-765    	*        6         311
 	DC.W    -283,-423,-888    	*      213         299
 	DC.W    -700,625,406    	*      311          23
 	DC.W    -258,-542,828    	*       25         125
 	DC.W     559,380,-768    	*      235         228
 	DC.W     872,496,203    	*       60          11
 	DC.W     811,373,-500    	*       65         330
 	DC.W     -54,1019,-77    	*      176         184
 	DC.W     584,694,-473    	*      220         207
 	DC.W    -449,-690,-608    	*      213         323
 	DC.W    -285,-258,-949    	*       47         247
 	DC.W     -65,-692,-751    	*        5         227
 	DC.W    -511,-42,-886    	*      265         300
 	DC.W     329,427,-870    	*       37         301
 	DC.W     214,692,723    	*       17          44
 	DC.W    -807,534,-333    	*      123         199
 	DC.W    -674,688,-345    	*      315         340
 	DC.W    -791,166,-628    	*      281         322
 	DC.W    -318,547,-804    	*      329         308
 	DC.W    -676,581,502    	*      310          29
 	DC.W    -906,12,-476    	*      270         332
 	DC.W    -605,-397,-724    	*      236         314
 	DC.W    -617,-711,401    	*       40         156
 	DC.W     357,-279,-918    	*      128         296
 	DC.W      16,87,-1020    	*       10         275
 	DC.W      83,856,555    	*      185         147
 	DC.W     420,-186,-914    	*      113         296
 	DC.W     618,-779,-239    	*      141         346
 	DC.W     376,747,590    	*      206         144
 	DC.W     612,-750,-331    	*      140         341
 	DC.W     210,294,957    	*      215         110
 	DC.W     476,-899,-116    	*      152         353
 	DC.W    -504,668,589    	*      322          35
 	DC.W     320,15,-972    	*      267         251
 	DC.W    -624,-119,-802    	*      259         308
 	DC.W      91,395,939    	*      193         113
 	DC.W      72,-14,1021    	*      281          94
 	DC.W    -932,423,-11    	*      114         180
 	DC.W    -530,-727,-488    	*      216         331
 	DC.W    -390,862,-390    	*      335         337
 	DC.W    -116,-145,-1006    	*       38         259
 	DC.W     662,177,-760    	*      254         227
 	DC.W      58,-537,-869    	*      353         238
 	DC.W     305,764,-609    	*       21         323
 	DC.W     725,-524,496    	*      305         150
 	DC.W     493,813,-378    	*      211         201
 	DC.W    -729,148,-703    	*      101         223
 	DC.W      60,-215,-999    	*      164         282
 	DC.W    -947,159,-353    	*       99         200
 	DC.W     555,475,-716    	*      229         224
 	DC.W    -336,-351,-900    	*      223         298
 	DC.W     709,-52,736    	*       94          46
 	DC.W     475,-260,868    	*      118          58
 	DC.W    -479,-265,-865    	*       61         237
 	DC.W    -221,-565,824    	*       21         126
 	DC.W     -18,42,-1022    	*      156         267
 	DC.W     737,276,654    	*       69          39
 	DC.W    -445,824,-411    	*      151         203
 	DC.W       0,-115,1017    	*      359          96
 	DC.W    -822,-606,64    	*      233           3

	ENDC


* Sphere is made up of Meridian Dots
	IFEQ	SSW-2
	XDEF	SPHERE,SPTS

SPTS:	SET	144

SPHERE:
 	DC.W	 0,989,265 		*  0   15
 	DC.W	 0,886,512 		*  0   30
 	DC.W	 0,724,724 		*  0   45
 	DC.W	 0,512,886 		*  0   60
 	DC.W	 0,265,989 		*  0   75
 	DC.W	 0,0,1024 		*  0   90
 	DC.W	 0,-265,989 		*  0   105
 	DC.W	 0,-512,886 		*  0   120
 	DC.W	 0,-724,724 		*  0   135
 	DC.W	 0,-886,512 		*  0   150
 	DC.W	 0,-989,265 		*  0   165
 	DC.W	 0,-1024,0 		*  0   180
 	DC.W	 0,-989,-265 		*  0   195
 	DC.W	 0,-886,-512 		*  0   210
 	DC.W	 0,-724,-724 		*  0   225
 	DC.W	 0,-512,-886 		*  0   240
 	DC.W	 0,-265,-989 		*  0   255
 	DC.W	 0,0,-1024 		*  0   270
 	DC.W	 0,265,-989 		*  0   285
 	DC.W	 0,512,-886 		*  0   300
 	DC.W	 0,724,-724 		*  0   315
 	DC.W	 0,886,-512 		*  0   330
 	DC.W	 0,989,-265 		*  0   345
 	DC.W	 0,1024,0 		*  0   360
 	DC.W	 494,856,265 		*  30   15
 	DC.W	 443,768,512 		*  30   30
 	DC.W	 362,627,724 		*  30   45
 	DC.W	 256,443,886 		*  30   60
 	DC.W	 132,229,989 		*  30   75
 	DC.W	 0,0,1024 		*  30   90
 	DC.W	 -132,-229,989 		*  30   105
 	DC.W	 -256,-443,886 		*  30   120
 	DC.W	 -362,-627,724 		*  30   135
 	DC.W	 -443,-768,512 		*  30   150
 	DC.W	 -494,-856,265 		*  30   165
 	DC.W	 -512,-886,0 		*  30   180
 	DC.W	 -494,-856,-265 	*  30   195
 	DC.W	 -443,-768,-512 	*  30   210
 	DC.W	 -362,-627,-724 	*  30   225
 	DC.W	 -256,-443,-886 	*  30   240
 	DC.W	 -132,-229,-989 	*  30   255
 	DC.W	 0,0,-1024 		*  30   270
 	DC.W	 132,229,-989 		*  30   285
 	DC.W	 256,443,-886 		*  30   300
 	DC.W	 362,627,-724 		*  30   315
 	DC.W	 443,768,-512 		*  30   330
 	DC.W	 494,856,-265 		*  30   345
 	DC.W	 512,886,0 		*  30   360
 	DC.W	 856,494,265 		*  60   15
 	DC.W	 768,443,512 		*  60   30
 	DC.W	 627,362,724 		*  60   45
 	DC.W	 443,256,886 		*  60   60
 	DC.W	 229,132,989 		*  60   75
 	DC.W	 0,0,1024 		*  60   90
 	DC.W	 -229,-132,989 		*  60   105
 	DC.W	 -443,-256,886 		*  60   120
 	DC.W	 -627,-362,724 		*  60   135
 	DC.W	 -768,-443,512 		*  60   150
 	DC.W	 -856,-494,265 		*  60   165
 	DC.W	 -886,-512,0 		*  60   180
 	DC.W	 -856,-494,-265 	*  60   195
 	DC.W	 -768,-443,-512 	*  60   210
 	DC.W	 -627,-362,-724 	*  60   225
 	DC.W	 -443,-256,-886 	*  60   240
 	DC.W	 -229,-132,-989 	*  60   255
 	DC.W	 0,0,-1024 		*  60   270
 	DC.W	 229,132,-989 		*  60   285
 	DC.W	 443,256,-886 		*  60   300
 	DC.W	 627,362,-724 		*  60   315
 	DC.W	 768,443,-512 		*  60   330
 	DC.W	 856,494,-265 		*  60   345
 	DC.W	 886,512,0 		*  60   360
 	DC.W	 989,0,265 		*  90   15
 	DC.W	 886,0,512 		*  90   30
 	DC.W	 724,0,724 		*  90   45
 	DC.W	 512,0,886 		*  90   60
 	DC.W	 265,0,989 		*  90   75
 	DC.W	 0,0,1024 		*  90   90
 	DC.W	 -265,0,989 		*  90   105
 	DC.W	 -512,0,886 		*  90   120
 	DC.W	 -724,0,724 		*  90   135
 	DC.W	 -886,0,512 		*  90   150
 	DC.W	 -989,0,265 		*  90   165
 	DC.W	-1024,0,0 		*  90   180
 	DC.W	 -989,0,-265 		*  90   195
 	DC.W	 -886,0,-512 		*  90   210
 	DC.W	 -724,0,-724 		*  90   225
 	DC.W	 -512,0,-886 		*  90   240
 	DC.W	 -265,0,-989 		*  90   255
 	DC.W	 0,0,-1024 		*  90   270
 	DC.W	 265,0,-989 		*  90   285
 	DC.W	 512,0,-886 		*  90   300
 	DC.W	 724,0,-724 		*  90   315
 	DC.W	 886,0,-512 		*  90   330
 	DC.W	 989,0,-265 		*  90   345
 	DC.W	 1024,0,0 		*  90   360
 	DC.W	 856,-494,265 		*  120   15
 	DC.W	 768,-443,512 		*  120   30
 	DC.W	 627,-362,724 		*  120   45
 	DC.W	 443,-256,886 		*  120   60
 	DC.W	 229,-132,989 		*  120   75
 	DC.W	 0,0,1024 		*  120   90
 	DC.W	 -229,132,989 		*  120   105
 	DC.W	 -443,256,886 		*  120   120
 	DC.W	 -627,362,724 		*  120   135
 	DC.W	 -768,443,512 		*  120   150
 	DC.W	 -856,494,265 		*  120   165
 	DC.W	 -886,512,0 		*  120   180
 	DC.W	 -856,494,-265 		*  120   195
 	DC.W	 -768,443,-512 		*  120   210
 	DC.W	 -627,362,-724 		*  120   225
 	DC.W	 -443,256,-886 		*  120   240
 	DC.W	 -229,132,-989 		*  120   255
 	DC.W	 0,0,-1024 		*  120   270
 	DC.W	 229,-132,-989 		*  120   285
 	DC.W	 443,-256,-886 		*  120   300
 	DC.W	 627,-362,-724 		*  120   315
 	DC.W	 768,-443,-512 		*  120   330
 	DC.W	 856,-494,-265 		*  120   345
 	DC.W	 886,-512,0 		*  120   360
 	DC.W	 494,-856,265 		*  150   15
 	DC.W	 443,-768,512 		*  150   30
 	DC.W	 362,-627,724 		*  150   45
 	DC.W	 256,-443,886 		*  150   60
 	DC.W	 132,-229,989 		*  150   75
 	DC.W	 0,0,1024 		*  150   90
 	DC.W	 -132,229,989 		*  150   105
 	DC.W	 -256,443,886 		*  150   120
 	DC.W	 -362,627,724 		*  150   135
 	DC.W	 -443,768,512 		*  150   150
 	DC.W	 -494,856,265 		*  150   165
 	DC.W	 -512,886,0 		*  150   180
 	DC.W	 -494,856,-265 		*  150   195
 	DC.W	 -443,768,-512 		*  150   210
 	DC.W	 -362,627,-724 		*  150   225
 	DC.W	 -256,443,-886 		*  150   240
 	DC.W	 -132,229,-989 		*  150   255
 	DC.W	 0,0,-1024 		*  150   270
 	DC.W	 132,-229,-989 		*  150   285
 	DC.W	 256,-443,-886 		*  150   300
 	DC.W	 362,-627,-724 		*  150   315
 	DC.W	 443,-768,-512 		*  150   330
 	DC.W	 494,-856,-265 		*  150   345
 	DC.W	 512,-886,0 		*  150   360

	ENDC

*===============================================================================
* Do sphere program on SSW = 1 or 2	
	IFGE	SSW-1
	IFLE	SSW-2
*===============================================================================
	TTL 'Music of the Spheres'
	PAGE

	XDEF	SMATH,SMLOOP,ORTHOG,SMCON

* Do the Sphere, using only the 68010
TST14:	
* Initialise Unit Vectors 
	MOVEA.W	#UV1,A0
	JSR	INITUV

	MOVEA.W	#UV2,A0
	JSR	INITUV

	MOVEA.W	#UV3,A0
	JSR	INITUV

	CLR.B	BUFFER

* Test 14 Main Loop
T14LP:	

* Decide which VG Buffer to use
	MOVEA.L	#VMEM,VG_PTR
	TST.B	BUFFER
	BEQ	T14A		*Buffer 1
	MOVEA.L VG_PTR,A0	
	MOVE.W	#$0EF00,(A0)	*Buffer 2 [JMPL 1E00] ($1E00/2=#0F00)
	ADD.L	#$1E00,VG_PTR

T14A	
	MOVE.W	#$8040,(A0)+		*CENTER
*	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box [It doesn't like this]

	BSR 	MPOTS		* Mediate the Pots

*Rotate as requested by the Pots and Switches
	JSR	TROTATE		

* Generate the Working Copy Unit Vectors for Ship 1
	MOVE.W	#UV2,A0
	MOVE.W	#UV1,A1
	JSR 	NWC_GEN		* Generate the Working Copy (Naked)

* Do the special Sphere Math
	BSR SMATH

* The transformed and projected Sphere is in the VG
*----
* Read and Debounce the Switches
	BSR	SWRIN

* Clear Watchdog Timer
	CLR.W	WDCLR		

* Thumb Switch - Decide whether to change the object
*	TST.B	LTHSW+3		* Left Thumb Switch?
*	BEQ	T12A		* no; keep going
*
*	CLR.B	LTHSW+3		* Yes. Clear the Flag and change the object
*	MOVE.W	OBJSEL,D0
*	ADDQ.W	#1,D0
*	CMP.W	#OBJMAX,D0	* Wrap around at maximum number of objects
*	BLE	T12C
*	CLR.W	D0
*T12C	MOVE.W	D0,OBJSEL


	MOVE.L	VG_PTR,A0	

	MOVE.W	#$2000,(A0)+	*VG Halt Instruction
	MOVE.L	A0,VG_PTR

	EOR.B	#1,BUFFER	*This Buffer is done

* Wait for Frame Sync (VG to be done)
* Wait for transition from IRQFRAME 3 to IRQFRAME 4, Then Reset IRQFRAME
T14B	CMP.B	#4,IRQFRAME
	BNE	T14B
T14C	CMP.B	#0,IRQFRAME
	BNE	T14C
	CLR.B	IRQFRAME

* Wait for VG to be done [should be done]	
T14D	BTST	#$00,INPUTS	
	BEQ	T14D

* Thumb Switch - Decide whether to Continue or to Return to the Menu.
	TST.B	RTHSW+3		* Right Thumb Switch?
	BEQ	T14E		* no; keep going

	CLR.B	RTHSW+3		* Yes. Clear the Flag and Return to the menu.
	JMP	MONS1

T14E	CLR.W	VGGO		* Start VG	

	CLR.W	WDCLR		* Kick the Watchdog 

* Go 'round again	

	BRA	T14LP	

*=============================================================================
* Special Sphere Math
*
* FOR THE DEMO SPHERE WE WILL DO AN INVERSE POSTADD WITH AN 
* ORTHOGONAL PROJECTION

SMATH:	
	MOVEA.W	#UV2,A0		* Unit Vectors

	LEA.L	SPHERE,A1	* Input data list
	MOVE.L	#SPTS,D5	* # of points

	MOVE.L	VG_PTR,A2
	CLR.W	CURRY
	CLR.W	CURRX
	
	MOVE.W	#$6760,(A2)+

SMLOOP:
	MOVE.W	X(A1),D0	*D0 = X 	$400 max
	MOVE.W	Y(A1),D1	*D1 = Y		$400 max
	MOVE.W	Z(A1),D2	*D2 = Z		$400 max

* XP
	CLR.L	D7		* clear accumulator
	MOVE.W	AX(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		* D7= AX*(X)

	MOVE.W	AY(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		* D7= AX*(X) + AY*(Y)

	MOVE.W	AZ(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		* D7= AX*(X) + AY*(Y) + AZ*(Z)

	BMI	SMCON		* Don't draw points behind the moon	
	MOVE.L	D7,A4		* A4 is used to store XP (32 bits)
*				 XP = AX*(X) + AY*(Y) + AZ*(Z) + XT <<<<<<<<<<<

*----------------------
	CLR.L	D7		* clear accumulator
	MOVE.W	BX(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		* D7= BX*(X)

	MOVE.W	BY(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		* D7= BX*(X) + BY*(Y)

	MOVE.W	BZ(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		* D7= BX*(X) + BY*(Y) + BZ*(Z) = 100 0000 max

	MOVE.L	D7,A5		* A5 is used to store YP (32 bits)
*				 YP = BX*(X) + BY*(Y) + BZ*(Z) <<<<<<<<<<<
*----------------------
	CLR.L	D7		* clear accumulator
	MOVE.W	CX(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		* D7= CX*(X)

	MOVE.W	CY(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		* D7= CX*(X) + CY*(Y)

	MOVE.W	CZ(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		* D7= ZP = CX*(X) + CY*(Y) + CZ*(Z)<<<<<<<<<<<

ORTHOG	
*	ASR.L	#1,D7		* Screen Y 
	SWAP	D7		* D7 = Zp = 40 max becomes screen y

	MOVE.L	A5,D6		* D6 = YP = 100 0000 max
*	ASR.L	#1,D6
	SWAP	D6		* D6 = Yp = 40 max becomes screen x 

SSW2	SET	0
	IFNE	SSW2

	MOVE.B	#$67,(A2)+	* color
	TST.W	D6		* Test screen X
	BPL	ORT1
	MOVE.B	#$20,(A2)+	* It is on the Far Side; Make it dim
	BRA	ORT2
ORT1	MOVE.W	D6,D0
	ASR.W	#1,D0
	ADD.W	#$20,D0
	MOVE.B	D0,(A2)+	* Brightness
ORT2	
	ENDC
*----
	MOVE.L	D7,D0
	SUB.W	CURRY,D0
	AND.W	#$1FFF,D0	
	MOVE.W	D0,(A2)+	* DY
	MOVE.W	D7,CURRY	* Update Current Y Position
*----
	MOVE.L	D6,D0
	SUB.W	CURRX,D0
	AND.W	#$1FFF,D0	
	OR.W	#$0000,D0	* To Draw it use $6000
	MOVE.W	D0,(A2)+	* Dx
	MOVE.W	D6,CURRX	* Update Current X Position
*----
	MOVE.W	#0,(A2)+	* Draw a dot
	MOVE.W	#$6000,(A2)+
*----
SMCON
	ADDQ.L	#6,A1		*3 words * 2 bytes for input table

	SUBQ.L	#1,D5		*Decrement point counter
	BNE	SMLOOP

	MOVE.W	#$8040,(A2)+
	MOVE.L	A2,VG_PTR

	RTS			
*===============================================================================
* END OF SPHERE STUFF
	ENDC
	ENDC
*===============================================================================
	IFEQ	SSW-3

	TTL 'Special Integrator Leakage Test'
	PAGE


* MONITOR TEST PATTERN #14 - Special Integrator Leakage Test

TST14:
	MOVEA.L	#VMEM,A0		* VG POINTER
	
	MOVE.W	#$8040,(A0)+
	MOVE.W	#$7200,(A0)+

	BSR	CINSTR			* Generate Color Instruction

	MOVE.W	#VJ_BKBOX,(A0)+		* Draw Beam Killer Box
	MOVE.W	#$8040,(A0)+		* Center

	MOVE.W	#$100,(A0)+		* dy
	MOVE.W	#$200,(A0)+		* dx

	BSR	BUSYIN			* Do 4000 STAT Instructions (18 ms)

	MOVE.W	#-$100,D0
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+		* -dy

	MOVE.W	#-$200,D0
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+		* -dx

	MOVE.W	#$2000,(A0)+		* VGHALT
	
TST14L	BSR	PSA			* Public Service Announcement:
*					  Start VG
*					  Wait for Frame Sync
*					  Read and Debounce switches
*					  Clear Watchdog Timer
*					  Thumb Switches- Change test?

	TST.B	RTHSW+3		* Right Thumb Switch?
	BEQ	TST14L		* no; This one is just going to loop

	CLR.B	RTHSW+3		* Yes. Clear the Flag and Return to the menu.
	JMP	MONS1
*------
	ENDC

*===============================================================================
	IFEQ	SSW-4

	TTL 'Patterns in Recognition'
	PAGE

	XDEF LFFIG,SINTBL,LFLOOP

PHASE	EQU	UV1



TST14:	
	MOVE.W	#128,PHASE	* PHASE = 90 DEGREES
	CLR.B	BUFFER

* Test 13 Main Loop
T14LP:	

* Decide which VG Buffer to use
	MOVEA.L	#VMEM,VG_PTR
	TST.B	BUFFER
	BEQ	T14A		*Buffer 1
	MOVEA.L VG_PTR,A0	
	MOVE.W	#$0EF00,(A0)	*Buffer 2 [JMPL 1E00] ($1E00/2=#0F00)
	ADD.L	#$1E00,VG_PTR

T14A	
	MOVE.W	#$8040,(A0)+		*CENTER
	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box 

	BSR 	MPOTS		* Mediate the Pots

* Do the LJ Figure
	BSR LJFIG

* It is alive in the VG
*----
* Read and Debounce the Switches
	BSR	SWRIN

	MOVE.L	VG_PTR,A0	

	MOVE.W	#$2000,(A0)+	*VG Halt Instruction
	MOVE.L	A0,VG_PTR

	EOR.B	#1,BUFFER	*This Buffer is done

* Wait for Frame Sync (VG to be done)
* Wait for transition from IRQFRAME 3 to IRQFRAME 4, Then Reset IRQFRAME
T14B	CMP.B	#4,IRQFRAME
	BNE	T14B
T14C	CMP.B	#0,IRQFRAME
	BNE	T14C
	CLR.B	IRQFRAME

* Wait for VG to be done [should be done]	
T14D	BTST	#$00,INPUTS	
	BEQ	T14D

* Thumb Switch - Decide whether to Continue or to Return to the Menu.
	TST.B	RTHSW+3		* Right Thumb Switch?
	BEQ	T14E		* no; keep going

	CLR.B	RTHSW+3		* Yes. Clear the Flag and Return to the menu.
	JMP	MONS1

T14E	CLR.W	VGGO		* Start VG	
	CLR.W	WDCLR		* Clear Watchdog Timer

* Go 'round again	
	BRA	T14LP	

*=============================================================================
LJFIG:
* Do Stuff
*---------
* For T = 0 to 255  (256 ANGLES)	
*  XPOS = K * SIN (wT)
*  YPOS = K * COS (wT) = K * SIN (wT + 128)
*  DRAWTO XPOS,YPOS
* Next T
*	MOVE.W	#510,D0		* T
	CLR.L	D0		* T
	CLR.L	D1		* D1 = XPOS
	CLR.L	D2		* D2 = YPOS
	CLR.L	D3		* D3 = OLDX
	CLR.L	D4		* D4 = OLDY

	MOVE.L	VG_PTR,A0	* A0 = VG pointer
	MOVE.W 	#$7200,(A0)+
	MOVE.W	#$6480,(A0)+

*Do the first one so the vector can be blanked
	MOVE.W	D0,D6		* D6 = T
	AND.W	#$1FF,D6	* WRAP AT 512
	MOVE.L	#SINTBL,A1	
	ADDA	D6,A1		
	MOVE.W	(A1),D1		* D1 = SIN (T)
	ASR.W	#6,D1

	MOVE.W	D0,D6		* D6 = T
	ADD.W	PHASE,D6	* D6 = T*(1+FREQ) + PHASE
	AND.W	#$1FF,D6	* WRAP AT 512	
	MOVE.W	#SINTBL,A1
	ADDA	D6,A1	
	MOVE.W 	(A1),D2		* D2 = SIN (T+PHASE)
	ASR.W	#6,D2

	MOVE.W	D2,D5		* YPOS
	SUB.W	D4,D5		* YPOS-OLDY
	AND.W	#$1FFF,D5	* dy
	MOVE.W	D5,(A0)+

	MOVE.W	D1,D5		* XPOS
	SUB.W	D3,D5		* XPOS-OLDX
	AND.W 	#$1FFF,D5	* dx
	OR.W	#$0000,D5	* z
	MOVE.W	D5,(A0)+

	MOVE.W	D2,D4		* YPOS is new OLDY
	MOVE.W	D1,D3		* XPOS is new OLDX

	ADD.W	#2,D0
*	CMP.W	#512,D0
*	BNE	LOOP
*	MOVE.L	A0,VG_PTR

LJLOOP:	MOVE.W	D0,D6
	AND.W	#$1FF,D6
	MOVE.L	#SINTBL,A1
	ADDA	D6,A1
	MOVE.W	(A1),D1		*
	ASR.W	#6,D1

*	MOVE.W	D0,D6
	MOVE.B	FREQ,D6
	EXT.W	D6		
	MULS	D0,D6		* D6 = T*FREQ
	ASR.W	#4,D6
	ADD.W	D0,D6		* D6 = T*(1+FREQ)
	ADD.W	PHASE,D6

	ASR.W	#1,D6
	ASL.W	#1,D6

	AND.W	#$1FF,D6
	MOVE.W	#SINTBL,A1
	ADDA	D6,A1	
	MOVE.W 	(A1),D2
	ASR.W	#6,D2

	MOVE.W	D2,D5		* YPOS
	SUB.W	D4,D5		* YPOS-OLDY
	AND.W	#$1FFF,D5	* dy
	MOVE.W	D5,(A0)+

	MOVE.W	D1,D5		* XPOS
	SUB.W	D3,D5		* XPOS-OLDX
	AND.W 	#$1FFF,D5	* dx
	OR.W	#$8000,D5	* z
	MOVE.W	D5,(A0)+

	MOVE.W	D2,D4		* YPOS is new OLDY
	MOVE.W	D1,D3		* XPOS is new OLDX

	ADD.W	#2,D0
	CMP.W	#512,D0
	BNE	LJLOOP
	MOVE.L	A0,VG_PTR

	RTS
*---------
* End of Stuff

SINTBL
 	DC.W        0,402,803,1205,1605,2005,2404,2801
 	DC.W     3196,3589,3980,4369,4756,5139,5519,5896
 	DC.W     6269,6639,7005,7366,7723,8075,8423,8765
 	DC.W     9102,9434,9759,10079,10393,10701,11002,11297
 	DC.W    11585,11866,12139,12406,12665,12916,13159,13395
 	DC.W    13622,13842,14053,14255,14449,14634,14810,14978
 	DC.W    15136,15286,15426,15557,15678,15790,15892,15985
 	DC.W    16069,16142,16206,16260,16305,16339,16364,16379
 	DC.W    16384,16379,16364,16339,16305,16260,16206,16142
 	DC.W    16069,15985,15892,15790,15678,15557,15426,15286
 	DC.W    15136,14978,14810,14634,14449,14255,14053,13842
 	DC.W    13622,13395,13159,12916,12665,12406,12139,11866
 	DC.W    11585,11297,11002,10701,10393,10079,9759,9434
 	DC.W     9102,8765,8423,8075,7723,7366,7005,6639
 	DC.W     6269,5896,5519,5139,4756,4369,3980,3589
 	DC.W     3196,2801,2404,2005,1605,1205,803,402
 	DC.W        0,-402,-803,-1205,-1605,-2005,-2404,-2801
 	DC.W    -3196,-3589,-3980,-4369,-4756,-5139,-5519,-5896
 	DC.W    -6269,-6639,-7005,-7366,-7723,-8075,-8423,-8765
 	DC.W    -9102,-9434,-9759,-10079,-10393,-10701,-11002,-11297
 	DC.W   -11585,-11866,-12139,-12406,-12665,-12916,-13159,-13395
 	DC.W   -13622,-13842,-14053,-14255,-14449,-14634,-14810,-14978
 	DC.W   -15136,-15286,-15426,-15557,-15678,-15790,-15892,-15985
 	DC.W   -16069,-16142,-16206,-16260,-16305,-16339,-16364,-16379
 	DC.W   -16384,-16379,-16364,-16339,-16305,-16260,-16206,-16142
 	DC.W   -16069,-15985,-15892,-15790,-15678,-15557,-15426,-15286
 	DC.W   -15136,-14978,-14810,-14634,-14449,-14255,-14053,-13842
 	DC.W   -13622,-13395,-13159,-12916,-12665,-12406,-12139,-11866
 	DC.W   -11585,-11297,-11002,-10701,-10393,-10079,-9759,-9434
 	DC.W    -9102,-8765,-8423,-8075,-7723,-7366,-7005,-6639
 	DC.W    -6269,-5896,-5519,-5139,-4756,-4369,-3980,-3589
 	DC.W    -3196,-2801,-2404,-2005,-1605,-1205,-803,-402
*===============================================================================
	ENDC
*===============================================================================
* Test Serial Messages	
	IFEQ	SSW-5
	TTL 'Serial Messages'
	PAGE

	XREF	ASCII

	XDEF	SMSGS,SMSG0,SMSG1,SMSG2,SMSG3,SMSG4,SMSG5,SMSG6,SMSG7
	XDEF	TIMER,CINDX

TIMER	EQU	CCUV		* Character Timer
CINDX	EQU	CCUV+2		* Current Index Number

MSGFLAG EQU	CCUV+4		* 'The Message is done' Flag
MSGNUM	EQU	CCUV+6		* Number of Active Message

TIMERK	DC.W	3		* Character Timer Value
SMSGS:	DC.L	SMSG0,SMSG1,SMSG2,SMSG3,SMSG4,SMSG5,SMSG6,SMSG7,SMSG8,SMSG9
	DC.L	SMSG10,SMSG11,SMSG12,SMSG13,SMSG14,SMSG15,SMSG16,SMSG17,SMSG18
	DC.L	SMSG19,SMSG20,SMSG21,SMSG22,SMSG23,SMSG24,SMSG25,SMSG26,SMSG27
	DC.L	SMSG28,SMSG29,SMSG30,SMSG31,SMSG32,SMSG33,SMSG34,SMSG35,SMSG36
*-------------------------------------------------------------------------------
* DC.W:	XP, YP	DC.B: Color, #Letters, 'Message'

SMSG0:	DC.W	-480,144
	DC.B	BLUE,25,'DO YOU WANT TO LINK GAMES'

SMSG1:	DC.W	-50,50
	DC.B	GREEN,13,'YES        NO'

SMSG2:	DC.W	-480,144
	DC.B	BLUE,20,'SELECT YOUR AIRCRAFT'

SMSG3:	DC.W	-100,50
	DC.B	WHITE,25,'F14   HELICOPTER   CESSNA'

SMSG4:	DC.W	-480,144
	DC.B	BLUE,19,'SELECT YOUR MISSION'

SMSG5:	DC.W	-100,50
	DC.B	WHITE,19,'TRAINING     COMBAT'
	
SMSG6:	DC.W	-288,-300
	DC.B	YELLOW,24,'PLACE CURSOR OVER OPTION'

SMSG7:	DC.W	-208,-348
	DC.B	YELLOW,17,'AND PRESS TRIGGER'

SMSG8:	DC.W	-480,144
	DC.B	RED,42,'YOU HAVE SELECTED GLOBAL THERMONUCLEAR WAR'

SMSG9:	DC.W	-480,144
	DC.B	BLUE,37,'0123456789 ABCDEFGHIJKLMNOPQRSTUVWXYZ'

SMSG10:	DC.W	-250,100
	DC.B	GREEN,22,'ADJUST X SIZE, X CNTR,'

SMSG11:	DC.W	-250,50
	DC.B	GREEN,21,'Y SIZE, AND Y CNTR TO'

SMSG12: DC.W	-270,0
	DC.B	GREEN,24,'PUT THE BLUE DOTS IN THE'

SMSG13:	DC.W	-250,-50
	DC.B	GREEN,21,'CORNERS OF THE SCREEN'	
*---
SMSG14:	DC.W	-480,150
	DC.B	BLUE,39,'ADJUST XINT AND YINT TO ALIGN THE BOXES'
*---
SMSG15:	DC.W	-470,100
	DC.B	BLUE,39,'ADJUST XBIP AND YBIP TO ALIGN THE BOXES'
*---
SMSG16: DC.W	-240,100
	DC.B	BLUE,20,'ADJUST XLIN AND YLIN' 
*---
SMSG17:	DC.W	-312,50
	DC.B	BLUE,26,'TO MAKE THE LINES STRAIGHT'
*---
SMSG18:	DC.W	-312,-100
	DC.B	BLUE,4,'DATE'
*---
SMSG19:	DC.W	-110,-138
	DC.B	BLUE,4,'TIME'
*---
SMSG20:	DC.W	-90,-138
	DC.B	BLUE,4,'DAY'
*---
SMSG21: DC.W	-90,-138
	DC.B	RED,6,'SUNDAY'
*---
SMSG22: DC.W	-90,-138
	DC.B	BLUE,6,'MONDAY'
*---
SMSG23: DC.W	-102,-138
	DC.B	GREEN,7,'TUESDAY'
*---
SMSG24: DC.W	-126,-138
	DC.B	GREEN,9,'WEDNESDAY'
*---
SMSG25: DC.W	-114,-138
	DC.B	GREEN,8,'THURSDAY'
*---
SMSG26: DC.W	-90,-138
	DC.B	GREEN,6,'FRIDAY'
*---
SMSG27: DC.W	-114,-138
	DC.B	RED,8,'SATURDAY'
*---
SMSG28:	DC.W	-460,250
	DC.B	GREEN,40,'PLACE CURSOR OVER THE ITEM TO BE CHANGED'
*---
SMSG29:	DC.W	-288,200
	DC.B	GREEN,24,'RIGHT TRIGGER INCREMENTS'
*---
SMSG30:	DC.W	-276,150
	DC.B	GREEN,23,'LEFT TRIGGER DECREMENTS'
*---
SMSG31: DC.W	-348,100
	DC.B	GREEN,29,'PRESS THE RIGHT THUMB TO EXIT'
*---
SMSG32: DC.W	-240,-200
	DC.B	RED,20,'POWER DOWN THE CLOCK'
*---
SMSG33:	DC.W	-204,-250
	DC.B	RED,17,'RESTART THE CLOCK'
*---
SMSG34	DC.W	-204,-300
	DC.B	RED,11,'CALIBRATION'
*---
SMSG35: DC.W	-300,-350
	DC.B	YELLOW,10,'PROTO KS 1'
*---
SMSG36: DC.W	10,-350
	DC.B	YELLOW,10,'PROTO KS 2'
*---
*===============================================================================
	PAGE
	
TST14:	MOVE.B	#$60,ZSCALE	* Initialise Brightness
	CLR.B	BUFFER
	MOVE.W	#8,D0		* Message Number
	BSR	INMSG		* Initiate Message

* Test 14 Main Loop
T14LP:	

* Decide which VG Buffer to use
	MOVEA.L	#VMEM,VG_PTR
	TST.B	BUFFER
	BEQ	T14A		*Buffer 1
	MOVEA.L VG_PTR,A0	
	MOVE.W	#$0EF00,(A0)	*Buffer 2 [JMPL 1E00] ($1E00/2=#0F00)
	ADD.L	#$1E00,VG_PTR

T14A	
	MOVE.W	#$8040,(A0)+		*CENTER
	MOVE.W	#$7200,(A0)+		* Scale 2
	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box 
	MOVE.L	A0,VG_PTR
*----
	BSR	DOMSG			* Do the message
*----
* Read and Debounce the Switches
	BSR	SWRIN

	MOVE.L	VG_PTR,A0	

	MOVE.W	#$2000,(A0)+	*VG Halt Instruction
	MOVE.L	A0,VG_PTR

	EOR.B	#1,BUFFER	*This Buffer is done

* Wait for Frame Sync (VG to be done)
* Wait for transition from IRQFRAME 3 to IRQFRAME 4, Then Reset IRQFRAME
T14B	CMP.B	#4,IRQFRAME
	BNE	T14B
T14C	CMP.B	#0,IRQFRAME
	BNE	T14C
	CLR.B	IRQFRAME

* Wait for VG to be done [should be done]	
T14D	BTST	#$00,INPUTS	
	BEQ	T14D

* Thumb Switch - Decide whether to Continue or to Return to the Menu.
	TST.B	RTHSW+3		* Right Thumb Switch?
	BEQ	T14E		* no; keep going

	CLR.B	RTHSW+3		* Yes. Clear the Flag and Return to the menu.
	JMP	MONS1

T14E	CLR.W	VGGO		* Start VG	

	CLR.W	WDCLR		* Clear Watchdog Timer 

* Go 'round again	

	BRA	T14LP	
*-------------------------------------------------------------------------------
* Initialize Message, Message Number in D0
INMSG	MOVE.B	D0,MSGNUM
	MOVE.W	TIMERK,TIMER		* Initialise Timer
* Make a Sound Here
	MOVE.W	#1,CINDX		* Set up Character Counter
	CLR.B	MSGFLAG			* Clear the 'Message is done' flag	
	RTS
*-------------------------------------------------------------------------------
DOMSG:
*Do a Message by its index Number 0 - ? in MSGNUM
*------------
* Get Address of Message Block Selected; put it into A1
	MOVE.B	MSGNUM,D0
	LSL.B	#2,D0			* Long Addresses
	LEA.L	SMSGS,A1
	MOVE.L	0(A1,D0),A1	
*------------
* Draw Vector to Start of Message
	MOVE.L	VG_PTR,A0

	MOVE.W	2(A1),D0
	AND.W	#$1FFF,D0	
	MOVE.W	D0,(A0)+	* dy

	MOVE.W	(A1),D0
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+	* dx
*------------
* Select the appropriate Color
	MOVE.B	4(A1),D1	* Color
	AND.B	#$7,D1			* MASK COLOR BITS
	OR.B	#$60,D1			* STAT INSTRUCTION
	MOVE.B	D1,(A0)+
	MOVE.B	#$60,(A0)+		* ZSTAT Intensity, END OF STAT
*------------
	MOVE.W	CINDX,D1	* Current Character counter	
	MOVE.L	A1,A2		* Make a copy of the Message Block Pointer	
	ADDA	#6,A2		* Set it to the beginning of the characters
*------------
* Get next ASCII Character, Convert it to JSRL
DOMLP	MOVE.B	(A2)+,D0		* Next Character

	SUB.B	#$20,D0			* Subtract to get Index number
	LSL.B	#1,D0			* two bytes/JSRL
	EXT.W	D0
	LEA.L	ASCII,A3
	MOVE.W	0(A3,D0),(A0)+		* Get JSRL and put it into the VG
*------------
	SUBQ.B	#1,D1
	BNE	DOMLP			* Do another one
*------------
* End with a Center
	MOVE.W	#$8040,(A0)+
	MOVE.L	A0,VG_PTR
*------------
* Time to add another character?
	SUBQ.W	#1,TIMER
	BNE	DOMOUT			* no
	MOVE.W	TIMERK,TIMER		* Yes, and re-initialise timer

	MOVE.W	CINDX,D0
	CMP.B	5(A1),D0		* Max number of characters
	BEQ	DOM2			* Already at maximum
	ADDQ.W	#1,CINDX		* Do one more next time

* Sound goes here

DOM2	MOVE.B	#$0FF,MSGFLAG		* 'Message is done' flag	
DOMOUT	RTS
*===============================================================================
	ENDC

*Do a Message by its index Number 0 - ? in MSGNUM
* Do Entire Serial Message
* Gets VG Pointer from VG_PTR and puts updated pointer back in it
* Uses A0, A1, A2, A3, D0, D1, D3
* Ends with a CENTER
DOMSG2:
*------------
* Get Address of Message Block Selected; put it into A1
	MOVE.W	MSGNUM,D0
	LSL.W	#2,D0			* Long Addresses
	LEA.L	SMSGS,A1
	MOVE.L	0(A1,D0),A1	

	MOVE.B	5(A1),D3		* Number of characters
*------------
* Draw Vector to Start of Message
	MOVE.L	VG_PTR,A0

	MOVE.W	2(A1),D0
	AND.W	#$1FFF,D0	
	MOVE.W	D0,(A0)+	* dy

	MOVE.W	(A1),D0
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+	* dx
*------------
* Select the appropriate Color
	MOVE.B	4(A1),D1	* Color
	AND.B	#$7,D1			* MASK COLOR BITS
	OR.B	#$60,D1			* STAT INSTRUCTION
	MOVE.B	D1,(A0)+
	MOVE.B	#$60,(A0)+		* ZSTAT Intensity, END OF STAT
*------------
	MOVE.L	A1,A2		* Make a copy of the Message Block Pointer	
	ADDA	#6,A2		* Set it to the beginning of the characters
*------------
* Get next ASCII Character, Convert it to JSRL
DOM2LP	MOVE.B	(A2)+,D0		* Next Character

	SUB.B	#$20,D0			* Subtract to get Index number
	LSL.B	#1,D0			* two bytes/JSRL
	EXT.W	D0
	LEA.L	ASCII,A3
	MOVE.W	0(A3,D0),(A0)+		* Get JSRL and put it into the VG
*------------
	SUBQ.B	#1,D3
	BNE	DOM2LP			* Do another one
*------------
* End with a Center
	MOVE.W	#$8040,(A0)+
	MOVE.L	A0,VG_PTR
*------------
	RTS
*===============================================================================
* CLOCK STUFF

	XDEF	READCLK,DISPCLK,CLKINIT,CLKSET,CLKRES,CLKRES2

* Clock Locations
YEAR	EQU	$0FFFFDFFE
MONTH	EQU	$0FFFFDFFC
DATE	EQU	$0FFFFDFFA
DAY	EQU	$0FFFFDFF8
HOUR	EQU	$0FFFFDFF6
MINUTE	EQU	$0FFFFDFF4
SECOND	EQU	$0FFFFDFF2
CLKCON	EQU	$0FFFFDFF0

DYR	EQU	$0FFFFDFEE
DMON	EQU	$0FFFFDFEC
DDATE	EQU	$0FFFFDFDA
DDAY	EQU	$0FFFFDFD8
DHOUR	EQU	$0FFFFDFD6
DMIN	EQU	$0FFFFDFD4
DSEC	EQU	$0FFFFDFD2

CRTIME	EQU	$0FFFFDFD0		* Timer for restarting the oscillator

* Read The Clock
* If the Clock is different from the shadow locations, then it must have
* changed, so read it again and update the shadow locations. 

READCLK:
	MOVE.B	DSEC,D0
	CMP.B	SECOND,D0
	BNE	RCLKBR
	RTS			* Time has not changed

RCLKBR	MOVE.B	SECOND,DSEC
	MOVE.B	MINUTE,DMIN
	MOVE.B	HOUR,DHOUR
	MOVE.B	DAY,DDAY
	MOVE.B	DATE,DDATE	
	MOVE.B	MONTH,DMON
	MOVE.B	YEAR,DYR

	RTS

*=====================
* Clock Display Positions: X Pos, Y Pos
	AND.W	#$1FFF,D0	

MDY_X	EQU	-255			* Month-Date-Year X Position	
MDY_Y	EQU	-75			* Month-Date-Year Y Position	

HMS_X	EQU	50			* Hour:Minute:Second X Position
HMS_Y	EQU	-75			* Hour:Minute:Second Y Position

* DISPLAY THE CLOCK
DISPCLK:

	MOVE.W	#MDY_Y&$1FFF,D0
	MOVE.W	D0,(A0)+		*DY
	MOVE.W	#MDY_X&$1FFF,D0
	MOVE.W	D0,(A0)+		*DX

	MOVE.W	#$6140,(A0)+		* COLOR	

	MOVE.B	DMON,D0			* MONTH
	JSR	VW_2D

	MOVE.W 	#51,D0			* '-'
	BSR	ACHAR

	MOVE.B	DDATE,D0		* DATE
	JSR	VW_2D

	MOVE.W 	#51,D0			* '-'
	BSR	ACHAR

	MOVE.B	DYR,D0			* YEAR
	JSR	VW_2D

	MOVE.W	#$8040,(A0)+		* CENTER

	MOVE.W	#HMS_Y&$1FFF,D0
	MOVE.W	D0,(A0)+		*DY
	MOVE.W	#HMS_X&$1FFF,D0
	MOVE.W	D0,(A0)+		*DX

	MOVE.W	#$6240,(A0)+		* COLOR	
	
	MOVE.B	DHOUR,D0		* HOUR
	JSR	VW_2D

	MOVE.W 	#37,D0			* ':'
	BSR	ACHAR

	MOVE.B	DMIN,D0			* MINUTE
	JSR	VW_2D

	MOVE.W 	#37,D0			* ':'
	BSR	ACHAR

	MOVE.B	DSEC,D0			* SECOND
	JSR	VW_2D

	MOVE.W	#$8040,(A0)+		* CENTER
	
	MOVE.L	A0,VG_PTR
	CLR.W	D0
	MOVE.B	DDAY,D0
	AND.B	#$07,D0
	ADD.W	#20,D0
	MOVE.W	D0,MSGNUM
	BSR	DOMSG2	

	RTS

* Makes sure the various control bits are zero. Does not reset the time
CLKINIT:
	CLR.B	CLKCON
	CLR.B	SECOND
	CLR.B	MONTH		
	CLR.B	DATE		
	CLR.B	DAY
	CLR.B	HOUR
	CLR.B	MINUTE

	MOVE.B	#$40,CLKCON
	CLR.B	CLKCON
	RTS

* For now, reset the clock by hand
CLKSET:
	MOVE.B	#$80,CLKCON	* Write Mode
	MOVE.B	#$10,MONTH
	MOVE.B	#$01,DATE
	MOVE.B	#$86,YEAR

	MOVE.B	#$4,DAY

	MOVE.B	#0,HOUR
	MOVE.B	#0,MINUTE
	MOVE.B	#0,SECOND

	CLR.B	CLKCON
	RTS

* Run this routine on Single-Step until they fix the Chip.
CLKRES:
	MOVE.B	#$80,SECOND	* STOP BIT ON
	MOVE.B	#$80,CLKCON	* WRITE BIT ON
	CLR.B	SECOND		* STOP BIT OFF
	MOVE.B	#$80,HOUR	* KICK START ON
	CLR.B	CLKCON		* WRITE BIT OFF
	
CLKRES2	NOP			

* Turn off the power to the Chip.
* Wait for 30 sec
* Turn on the power to the Chip.
* Wait 2 seconds
* Resume the program

	NOP

	MOVE.B	#$80,CLKCON	* WRITE BIT ON
	CLR.B	HOUR		* KICK START OFF

	BSR	CLKSET		* SET THE TIME

CLKRES3	BRA	CLKRES3
	

* GET JSRL FOR CHARACTER THAT IS INDEXED FROM VG ALPHA NUMERICS JSRL TABLE
* INPUT CHARACTER IN D0
* A0 IS VG POINTER
* USES A3

ACHAR:	
	LSL.B	#1,D0		* two bytes/JSRL
	EXT.W	D0
	LEA.L	VGIMAGE,A3
	MOVE.W	0(A3,D0),(A0)+	* Get JSRL and put it into the VG
	RTS


* Do Entire Serial Message

DOMSG3:
* Do a Message by its index Number in D0 (.W)
* Ignore Message Position in the Table
* VG Pointer in A0
* Ends with a Center
*------------
* Get Address of Message Block Selected; put it into A1
	LSL.W	#2,D0			* Long Addresses
	LEA.L	SMSGS,A1
	MOVE.L	0(A1,D0),A1	

	MOVE.B	5(A1),D3		* Number of characters
*------------
* Select the appropriate Color
	MOVE.B	4(A1),D1	* Color
	AND.B	#$7,D1			* MASK COLOR BITS
	OR.B	#$60,D1			* STAT INSTRUCTION
	MOVE.B	D1,(A0)+
	MOVE.B	#$60,(A0)+		* ZSTAT Intensity, END OF STAT
*------------
	MOVE.L	A1,A2		* Make a copy of the Message Block Pointer	
	ADDA	#6,A2		* Set it to the beginning of the characters
*------------
* Get next ASCII Character, Convert it to JSRL
DOM3LP	MOVE.B	(A2)+,D0		* Next Character

	SUB.B	#$20,D0			* Subtract to get Index number
	LSL.B	#1,D0			* two bytes/JSRL
	EXT.W	D0
	LEA.L	ASCII,A3
	MOVE.W	0(A3,D0),(A0)+		* Get JSRL and put it into the VG
*------------
	SUBQ.B	#1,D3
	BNE	DOM3LP			* Do another one
*------------
* End with a Center
	MOVE.W	#$8040,(A0)+
*------------
	RTS

	XDEF	MPOS,MPCHK

* MESSAGE POSITIONS TABLE
* The Routine that uses this table will check the cursor against the
* Table entries and go to the Subroutine if a match is detected

* 		POSITION X, Position Y,  Width, Subroutine

MPOS:	DC.W	MDY_X,MDY_Y,46		* Month
	DC.L	CS0

	DC.W	MDY_X+24*3,MDY_Y,46	* Day
	DC.L	CS1

	DC.W	MDY_X+24*6,MDY_Y,46	* Year
	DC.L	CS2

	DC.W	HMS_X,HMS_Y,46		* Hours
	DC.L	CS3

	DC.W	HMS_X+24*3,HMS_Y,46	* Minutes
	DC.L	CS4

	DC.W	HMS_X+24*6,HMS_Y,46	* Seconds
	DC.L	CS5

	DC.W	-116,-140,212		* Day names
	DC.L	CS6

	DC.W	-240,-200,480		* Power Down the Clock
	DC.L	CS7

	DC.W	-220,-250,424		* Restart Clock
	DC.L	CS8

	DC.W	-204,-300,400		* Calibration
	DC.L	CS9

	DC.W	-300,-350,240		* Prototype Kickstart Part 1
	DC.L	CS10
	
	DC.W	10,-350,240		* Prototype Kickstart Part 2
	DC.L	CS11

MPLINES	DC.W	(MPLINES-MPOS)/10	* Number of Lines

* This Routine checks the cursor against the MPOS Table entries and goes 
* to the Subroutine if a match is detected

MPCHK:	LEA.L	MPOS,A1
	MOVE.W	MPLINES,D5

* IS THE CURSOR WITHIN BOUNDS?	
* X Position
MPLP	MOVE.W	XP,D0			* Cursor X position
	MOVE.W	(A1),D1			* Message X starting position
	CMP.W	D1,D0
	BMI	NXTMP			* Out of Bounds
	ADD.W	4(A1),D1		* Line Width
	CMP.W	D1,D0
	BPL	NXTMP			* Out of Bounds
* Y Position
	MOVE.W	YP,D0			* Cursor Y Position
	MOVE.W	2(A1),D1		* Message Y starting position
	CMP.W	D1,D0
	BMI	NXTMP			* Below lower limit
	ADD.W	LINEHT,D1	       * Lower Limit + Line Height = Upper Limit
	CMP.W	D1,D0
	BPL	NXTMP			* Above upper limit

* This one has been selected
	MOVE.L	6(A1),A2
* Draw a Yellow Box around it
	MOVE.W	#$6680,(A0)+

* Point to it
	MOVE.W	2(A1),D0		* y
	SUBQ.W	#4,D0
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+

	MOVE.W	(A1),D0			* x
	SUBQ.W	#4,D0
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A0)+

	MOVE.W	#0,(A0)+		* dy
	MOVE.W	4(A1),D0		* dx
	AND.W	#$1FFF,D0
	OR.W	#$6000,D0
	MOVE.W	D0,(A0)+		
	
	MOVE.W	#34,(A0)+		* dy
	MOVE.W	#$6000,(A0)+		* dx

	MOVE.W	#0,(A0)+		* dy
	MOVE.W	4(A1),D0		* dx
	NEG.W	D0
	AND.W	#$1FFF,D0
	OR.W	#$6000,D0
	MOVE.W	D0,(A0)+

	MOVE.W	#((-34)&$1FFF),(A0)+	* dy
	MOVE.W	#$6000,(A0)+		* dx

	MOVE.W	#$8040,(A0)+		* Center

*
* Draw a Dim Cursor
	MOVE.W	#$6220,(A0)+
	BSR	CRSOR3			* CURSOR

	JMP	(A2)			* Go There and Don't Come Back		

* Out of Bounds, Go to the next one
NXTMP	ADDA.L	#10,A1			* Point to the next line
	SUBQ.W	#1,D5			* Any More?
	BNE	MPLP			* Yes

* Draw a normal cursor and return to sender
	MOVE.W	#$6760,(A0)+	
	BSR	CRSOR3			* CURSOR

	CLR.B	LFSW+3		* Clear Left Trigger Flag
	CLR.B	RFSW+3		* Clear Right Trigger Flag

	RTS				* No More

*---------
* Month
CS0:	
	MOVE.W	#0,D0
	BSR	TIMESET
	RTS
*---------
* Date
CS1:	
	MOVE.W	#1,D0
	BSR	TIMESET
	RTS
*---------
* Year
CS2:	
	MOVE.W	#2,D0
	BSR	TIMESET
	RTS
*---------
* Hours
CS3:	
	MOVE.W	#3,D0
	BSR	TIMESET
	RTS
*---------
* Minutes
CS4:	
	MOVE.W	#4,D0
	BSR	TIMESET
	RTS
*---------
* Seconds
CS5:	
	MOVE.W	#5,D0
	BSR	TIMESET
	RTS
*---------
* Day names
CS6:	
	MOVE.W	#6,D0
	BSR	TIMESET
	RTS
*---------
* Power Down the Clock
CS7:	
	TST.B	RFSW+3		* Right Trigger Switch Flag?
	BNE	CS7A		* yes
	TST.B	LFSW+3		* Left Trigger Switch?
	BEQ	CS7B		* no
	RTS

* Do it
CS7A	CLR.B	RFSW+3		* Clear Right Trigger Flag
	CLR.B	LFSW+3		* Clear Left Trigger Flag
	OR.B	#$80,SECOND	* Set ST bit to one
CS7B	RTS
*---------
* Restart The Clock
CS8:	
	TST.B	RFSW+3		* Right Trigger Switch Flag?
	BNE	CS8A		* yes
	TST.B	LFSW+3		* Left Trigger Switch?
	BNE	CS8A		* no
	RTS
* Do it
CS8A	CLR.B	RFSW+3		* Clear Right Trigger Flag
	CLR.B	LFSW+3		* Clear Left Trigger Flag

* Set Write Bit to '1'
	OR.B	#$80,CLKCON

* Reset the Stop Bit to '0'
	AND.B	#$07F,SECOND

* Set the Kick Start Bit to '1'
	OR.B	#$80,HOUR	

* Reset the Write Bit to '0'
	AND.B	#$07F,CLKCON

* Wait 2 seconds ( This will freeze the display)
	MOVE.W	#$2000,(A0)+		* VGHALT
	MOVE.B	#100,CRTIME

CS8LP	BSR	PSA2		* Start VG
*				  Wait for Frame Sync
*				  Read and Debounce switches
*				  Clear Watchdog Timer
	SUB.B	#1,CRTIME
	BNE	CS8LP		

* Set the Write Bit to '1'
	OR.B	#$80,CLKCON

* Reset the Kick Start Bit to '0'
	AND.B	#$07F,HOUR

* Reset the clock Time
	MOVE.B	#$10,MONTH
	MOVE.B	#$01,DATE
	MOVE.B	#$86,YEAR

	MOVE.B	#$4,DAY

	MOVE.B	#0,HOUR
	MOVE.B	#0,MINUTE
	MOVE.B	#0,SECOND

* Reset the Write Bit to '0'
	AND.B	#$07F,CLKCON

	RTS
* --------------------------------------------------------------------
* Calibration Adjust 
CS9:	MOVE.W	#7,D0
	BSR	CALSET
	RTS
* --------------------------------------------------------------------
* Kickstart the Prototype, Part 1
CS10:	
	TST.B	RFSW+3		* Right Trigger Switch Flag?
	BNE	CS10A		* yes
	TST.B	LFSW+3		* Left Trigger Switch?
	BNE	CS10A		* no
	RTS
* Do it
CS10A	CLR.B	RFSW+3		* Clear Right Trigger Flag
	CLR.B	LFSW+3		* Clear Left Trigger Flag

* Set Write Bit to '1'
	OR.B	#$80,CLKCON

* Reset the Stop Bit to '0'
	AND.B	#$07F,SECOND

* Set the Kick Start Bit to '1'
	OR.B	#$80,HOUR	

* Reset the Write Bit to '0'
	AND.B	#$07F,CLKCON

* End of Part 1
	RTS

* Turn off the Timekeeper power for 30 secs,
* Then, Run Part 2
*-------------------------------------------------------------------------------
* Kickstart the Prototype, Part 2
CS11:	
	TST.B	RFSW+3		* Right Trigger Switch Flag?
	BNE	CS11A		* yes
	TST.B	LFSW+3		* Left Trigger Switch?
	BNE	CS11A		* no
	RTS
* Do it
CS11A	CLR.B	RFSW+3		* Clear Right Trigger Flag
	CLR.B	LFSW+3		* Clear Left Trigger Flag


* Set the Write Bit to '1'
	OR.B	#$80,CLKCON

* Reset the Kick Start Bit to '0'
	AND.B	#$07F,HOUR

* Reset the clock Time
	MOVE.B	#$10,MONTH
	MOVE.B	#$17,DATE
	MOVE.B	#$86,YEAR

	MOVE.B	#$4,DAY

	MOVE.B	#0,HOUR
	MOVE.B	#0,MINUTE
	MOVE.B	#0,SECOND

* Reset the Write Bit to '0'
	AND.B	#$07F,CLKCON

	RTS
* --------------------------------------------------------------------
* 
* Draw the Cursor; supply your own color
CRSOR3:		
	MOVE.B	RPOT0,D0		* 0 - 255
	ADD.B	#$80,D0			* - 128 TO +127
	EXT.W	D0
	ASL.W	#2,D0			* INCREASE CONTROL SENSITIVITY
	MOVE.W	YP,D1
	SUB.W	D1,D0			* Smooth it out
	ASR.W	#2,D0
	ADD.W	D1,D0			* New Position
	MOVE.W	D0,YP			* SAVE IT
	AND.W	#$1FFF,D0		
	MOVE.W	D0,(A0)+		* DY
		
	MOVE.B	RPOT1,D0		* 0 - 255
	ADD.B	#$80,D0			* - 128 TO +127
	EXT.W	D0
	ASL.W	#2,D0			* INCREASE CONTROL SENSITIVITY
	MOVE.W	XP,D1
	SUB.W	D1,D0			* Smooth it out
	ASR.W	#2,D0
	ADD.W	D1,D0			* New Position

	MOVE.W	D0,XP			* SAVE IT
	AND.W	#$1FFF,D0		
	MOVE.W	D0,(A0)+		* DX

	MOVE.W	#VJ_CRSR,(A0)+		* CURSOR
	MOVE.W	#$8040,(A0)+

	RTS	
*------------------------------------------------------------------------------

	XDEF	TIMETABLE,TIMESET,CALSET
TIMETABLE:
* Parameter to change; 
* Parameter Bit Mask;
* Low Wrap
* High Wrap
		
	DC.W	MONTH,$1F,$1,$12	
	DC.W	DATE,$3F,$1,$31
	DC.W	YEAR,$0FF,$86,$99
	DC.W	HOUR,$3F,$0,$23
	DC.W	MINUTE,$7F,$0,$59
	DC.W	SECOND,$7F,$0,$59
	DC.W	DAY,$07,$1,$07

* D0.W contains the index number
TIMESET:
	LEA.L	TIMETABLE,A2
	MULU	#8,D0		* [change to shift]
	ADDA	D0,A2		* A2 points to table entry

* Right Trigger?
	TST.B	RFSW+3		* Right Trigger Switch Flag?
	BEQ	TSLP2		* no
* Yes,  Clear Trigger Flag
	CLR.B	RFSW+3		* Clear Right Trigger Flag

* Increment and wrap if necessary
	AND.B	#$0EF,CCR	* Clear Extend Flag
	MOVE.B	#1,D2		* ADD Decimal is either R,R or mem,mem

	MOVE.W	(A2),A3		* Get parameter
	MOVE.B	(A3),D0
	ABCD	D2,D0

	CMP.B	7(A2),D0	* Compare to High Wrap
	BLE	TSLP1		* Overflow?
* Yes
	MOVE.B	5(A2),D0	* Make it wrap	

* Mask the data
TSLP1	MOVE.W	2(A2),D1	* Get the Bit Mask
	AND.B	D1,D0		* Apply the mask to the new data
	NOT.W	D1		* Complement the mask
	AND.B	(A3),D1		* Get the bits that will not be changed
	OR.B	D1,D0		* ready to write

	OR.B	#$80,CLKCON	* Set Write	
	MOVE.B	D0,(A3)		* Write Data
	AND.B	#$7F,CLKCON	* End Write

	BSR	RCLKBR		* Copy to the Shadow Display Registers

TSLP4	RTS			* End

* Left Trigger?
TSLP2
	TST.B	LFSW+3		* Left Trigger Switch Flag?
	BEQ	TSLP4		* no
* Yes,  Clear Trigger Flag
	CLR.B	LFSW+3		* Clear Left Trigger Flag

* Decrement and wrap if necessary
	AND.B	#$0EF,CCR	* Clear Extend Flag
	MOVE.B	#1,D2		* SUB Decimal is either R,R or mem,mem

	MOVE.W	(A2),A3		* Get parameter
	MOVE.B	(A3),D0
	SBCD	D2,D0

	CMP.B	5(A2),D0	* Compare to Low Wrap
	BPL	TSLP3		* Under flow?
* Yes
	MOVE.B	7(A2),D0	* Make it wrap

TSLP3	BRA	TSLP1		* Mask it and Write it
*===============================================================================
* Calibration increment/decrement
* Calibration is in Sign Magnitude
* Change it to two's complement, do increment or decrement, change it back.
CALSET:
	MOVE.B	CLKCON,D1
	MOVE.B	D1,D2
	AND.B	#$1F,D2
	BTST	#5,D1
	BEQ	CSET1		* positive
	NEG.B	D2		* Negative
* Ready

* Right Trigger?
CSET1	TST.B	RFSW+3		* Right Trigger Switch Flag?
	BEQ	CSET2		* no
* Yes,  Clear Trigger Flag
	CLR.B	RFSW+3		* Clear Right Trigger Flag

* Increment, but not past 31 
	CMP.B	#$1F,D2
	BEQ	CSET5		* done, exit without doing anything		

* ok to increment
	ADD.B	#1,D2
	BRA	CSET3		* done

* Left Trigger?
CSET2	TST.B	LFSW+3		* Left Trigger Switch Flag?
	BEQ	CSET5		* no, exit without doing anything
* Yes,  Clear Trigger Flag
	CLR.B	LFSW+3		* Clear Left Trigger Flag

* Decrement, but not past -31
	CMP.B	#-31,D2
	BEQ	CSET5		* done, exit without doing anything		
* ok to decrement
	SUB.B	#1,D2			

* Convert it back to sign magnitude
CSET3	TST.B	D2
	BPL	CSET4		* positive
	NEG.B	D2		* negative
	OR.B	#$20,D2

* Write it
CSET4	AND.B	#$3F,D2		* mask it to make sure
	OR.B	#$80,CLKCON	* Set Write	
	MOVE.B	D2,CLKCON	* Write Data
	AND.B	#$7F,CLKCON	* End Write

	BSR	RCLKBR		* Copy to the Shadow Display Registers

CSET5	RTS			* End
*===============================================================================
BCDTBL:
	DC.B	$00,$01,$02,$03,$04,$05,$06,$07,$08,$09
	DC.B	$10,$11,$12,$13,$14,$15,$16,$17,$18,$19
	DC.B	$20,$21,$22,$23,$24,$25,$26,$27,$28,$29
	DC.B	$30,$31

* Display Calibration
DSPCAL:	
	MOVE.B	CLKCON,D1	
	BTST	#5,D1
	BNE	CAL1

	MOVE.W	#(-300+10)&($1FFF),(A0)+	* dy
	MOVE.W	#109,(A0)+			* dx

	MOVE.W	#VJ_CRSR,(A0)+		* CURSOR is a '+'

	MOVE.W	#$8040,(A0)+		* Center

	BRA	CAL2

CAL1	MOVE.W	#(-300)&($1FFF),(A0)+	* dy
	MOVE.W	#100,(A0)+		* dx

	MOVE.W	#51,D0			* '-'
	BSR	ACHAR

	MOVE.W	#$8040,(A0)+		* Center

* We now have + or -

CAL2	AND.B	#$1F,D1			* Calibration number
	LEA.L	BCDTBL,A3
	MOVE.B	0(A3,D1),D0		* D0 contains BCD Calibration

	MOVE.W	#(-300)&($1FFF),(A0)+	* dy
	MOVE.W	#140,(A0)+		* dx

	JSR	VW_2D

	MOVE.W	#$8040,(A0)+		* Center

	RTS

*===============================================================================
	XDEF	DPOS,DPOS2,DSUB,DSUB2,DISPCLK2

DPOS:	DC.W	MDY_X,MDY_Y,DMON,$6140			* Month

	DC.W	MDY_X+24*3,MDY_Y,DDATE,$6140		* Day

	DC.W	MDY_X+24*6,MDY_Y,DYR,$6140		* Year

	DC.W	HMS_X,HMS_Y,DHOUR,$6240			* Hours

	DC.W	HMS_X+24*3,HMS_Y,DMIN,$6240		* Minutes

	DC.W	HMS_X+24*6,HMS_Y,DSEC,$6240		* Seconds

DPOS2:	DC.W	MDY_X+24*2+0,MDY_Y,$6660,51		* '-'

	DC.W	MDY_X+24*5+0,MDY_Y,$6660,51		* '-'

	DC.W	HMS_X+24*2+0,HMS_Y,$6660,37		* ':'

	DC.W	HMS_X+24*5+0,HMS_Y,$6660,37		* ':'


* Display data as specified by table entry
* End with Center
* Increment table pointer
*
* A0 is VG Pointer
* A2 is table address pointer
DSUB:	MOVE.W	2(A2),D2
	AND.W	#$1FFF,D2
	MOVE.W	D2,(A0)+		* dy

	MOVE.W	0(A2),D2
	AND.W	#$1FFF,D2
	MOVE.W	D2,(A0)+		* dx

	MOVE.W	6(A2),(A0)+		* COLOR	

	MOVE.W	4(A2),A3
	MOVE.B	(A3),D0
	JSR	VW_2D			* Value to display, USES D0,D1,A1
	
	ADDA	#08,A2
	MOVE.W	#$8040,(A0)+	* Center
	RTS

DSUB2:	MOVE.W	2(A2),D2
	AND.W	#$1FFF,D2
	MOVE.W	D2,(A0)+		* dy

	MOVE.W	0(A2),D2
	AND.W	#$1FFF,D2
	MOVE.W	D2,(A0)+		* dx

	MOVE.W	4(A2),(A0)+		* COLOR	

	MOVE.W	6(A2),D0
	BSR	ACHAR
	
	ADDA	#08,A2
	MOVE.W	#$8040,(A0)+	* Center
	RTS

* DISPLAY THE CLOCK
DISPCLK2:
	LEA.L	DPOS,A2

	BSR	DSUB		* MONTH
	BSR	DSUB		* DATE
	BSR	DSUB		* YEAR
	BSR	DSUB		* HOUR
	BSR	DSUB		* MINUTE
	BSR	DSUB		* SECOND

	LEA.L	DPOS2,A2

	BSR	DSUB2
	BSR	DSUB2
	BSR	DSUB2
	BSR	DSUB2

	MOVE.L	A0,VG_PTR

* Day Name
	CLR.W	D0
	MOVE.B	DDAY,D0
	AND.B	#$07,D0
	ADD.W	#20,D0
	MOVE.W	D0,MSGNUM
	BSR	DOMSG2	

	RTS

	END


