	TTL 'CLIP'

	INCLUDE 'COMN.ASM'

	XREF PRESUB

	SECTION PROGRAM

	XDEF GRID,GRLINE,CPROJ,PSTAT,CLOOP,XMIN
	XDEF PS1,PS2,PS3,PS4,PS5,PS6,PS7,PS8,PS9,PS10,PS11,PS12
	XDEF RE1,RE2,LE1,LE2,TE1,TE2,BE1,BE2,XE1,XE2
	XDEF HP1,HP2,HP3

X1	EQU	PTBL+$0
Y1	EQU	PTBL+$2
Z1	EQU	PTBL+$4

X2	EQU	PTBL+$6
Y2	EQU	PTBL+$8
Z2	EQU	PTBL+$0A

T	EQU	PTBL+$0C

GRLINE	DC.W	$1000,$2000,$40
	DC.W	$200,$2000,$40
XMIN	DC.W	$100

GRID:	

* Observer in A0, Point list in A1 (neither is modified), output in XP, YP, ZP
	MOVE.W 	#UV2,A0		
	MOVE.W	#GRLINE,A1
	JSR	PRESUB
	MOVE.W	XP,A2		* Save it in the Address Registers
	MOVE.W	YP,A3
	MOVE.W	ZP,A4

	ADD.L	#6,A1		* Get the second point
	JSR	PRESUB

	MOVE.W	XP,D3		* PX2
	MOVE.W	YP,D4		* PY2
	MOVE.W	ZP,D5		* PZ2

	MOVE.W	A2,D0		* PX1
	MOVE.W	A3,D1		* PY1
	MOVE.W	A4,D2		* PZ1

	BSR	PSTAT		* Form the Point Status Bytes

* If STAT1 and STAT2 are both zero, the line is totally visible
CLOOP:	OR.B	STAT1,D7
	BNE	PS11
* Project and display the line
	BRA	CPROJ
* If STAT1 and STAT2 have common bits set, it is totally invisible
PS11	MOVE.B	STAT1,D7
	AND.B	STAT2,D7
	BEQ	PS12
	RTS

PS12	MOVEM.W	D0-D5,PTBL	*Save the registers
	PAGE
*----------------------------
* This is the hard part
*----------------------------
HP1	
	BTST.B	#0,STAT2
	BNE	TE1
	BTST.B	#1,STAT2
	BNE	BE1
	BTST.B	#2,STAT2
	BNE	RE1
	BTST.B	#3,STAT2
	BNE	LE1
	BTST.B	#4,STAT2
	BNE	XE1

HP2	BTST.B	#0,STAT1
	BNE	TE2
	BTST.B	#1,STAT1
	BNE	BE2
	BTST.B	#2,STAT1
	BNE	RE2
	BTST.B	#3,STAT1
	BNE	LE2
	BTST.B	#4,STAT1
	BNE	XE2

HP3	RTS
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 2 to the Right Edge, Y=X
*
*	T =    (Y1-X1)
*	    ---------------
*	    (X2-X1)-(Y2-Y1)
*
RE1:	MOVE.W	X2,D3
	SUB.W	X1,D3
	SUB.W	Y2,D3
	ADD.W	Y1,D3

	MOVE.W	Y1,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D3,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D3
	SUB.W	X1,D3
	MULS	D6,D3
	ASL.L	#2,D3
	SWAP	D3		
	ADD.W	X1,D3		* D3 = Xv

* Yv = Xv
	MOVE.W	D3,D4		* D4 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D5
	SUB.W	Z1,D5
	MULS	D6,D5
	ASL.L	#2,D5
	SWAP	D5
	ADD.W	Z1,D5		* D5 = Zv

	BSR	PSTAT
	BCLR.B	#2,STAT2
	BRA	CLOOP

* Clip Point 1 to the Right Edge, Y=X
RE2:	MOVE.W	X2,D0
	SUB.W	X1,D0
	SUB.W	Y2,D0
	ADD.W	Y1,D0

	MOVE.W	Y1,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D0,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D0
	SUB.W	X1,D0
	MULS	D6,D0
	ASL.L	#2,D0
	SWAP	D0		
	ADD.W	X1,D0		* D0 = Xv

* Yv = Xv
	MOVE.W	D0,D1		* D1 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D2
	SUB.W	Z1,D2
	MULS	D6,D2
	ASL.L	#2,D2
	SWAP	D2
	ADD.W	Z1,D2		* D2 = Zv

	BSR	PSTAT
	BCLR.B	#2,STAT1
	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 2 to the Left Edge, Y=-X
*
* 	T =    -(X1+Y1)
*	    ---------------
*	    (X2-X1)+(Y2-Y1)
*
LE1:	MOVE.W	X2,D3
	SUB.W	X1,D3
	ADD.W	Y2,D3
	SUB.W	Y1,D3

	MOVE.W	Y1,D6
	NEG.W	D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D3,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D3
	SUB.W	X1,D3
	MULS	D6,D3
	ASL.L	#2,D3
	SWAP	D3		
	ADD.W	X1,D3		* D3 = Xv

* Yv = -Xv
	MOVE.W	D3,D4		
	NEG.W	D4		* D4 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D5
	SUB.W	Z1,D5
	MULS	D6,D5
	ASL.L	#2,D5
	SWAP	D5
	ADD.W	Z1,D5		* D5 = Zv

	BSR	PSTAT
	BCLR.B	#3,STAT2
	BRA	CLOOP

* Clip Point 2 to the Left Edge, Y=-X
LE2:	MOVE.W	X2,D0
	SUB.W	X1,D0
	ADD.W	Y2,D0
	SUB.W	Y1,D0

	MOVE.W	Y1,D6
	NEG.W	D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D0,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D0
	SUB.W	X1,D0
	MULS	D6,D0
	ASL.L	#2,D0
	SWAP	D0		
	ADD.W	X1,D0		* D0 = Xv

* Yv = -Xv
	MOVE.W	D0,D1		
	NEG.W	D1		* D1 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D2
	SUB.W	Z1,D2
	MULS	D6,D2
	ASL.L	#2,D2
	SWAP	D2
	ADD.W	Z1,D2		* D2 = Zv

	BSR	PSTAT
	BCLR.B	#3,STAT1
	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 2 to the Top Edge, Z=X
*
*	T =    (Z1-X1)
*	    ---------------
*	    (X2-X1)-(Z2-Z1)
*
TE1:	MOVE.W	X2,D3
	SUB.W	X1,D3
	SUB.W	Z2,D3
	ADD.W	Z1,D3

	MOVE.W	Z1,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D3,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D3
	SUB.W	X1,D3
	MULS	D6,D3
	ASL.L	#2,D3
	SWAP	D3		
	ADD.W	X1,D3		* D3 = Xv

* Yv = (Y2-Y1)*T + Y1
	MOVE.W	Y2,D4
	SUB.W	Y1,D4
	MULS	D6,D4
	ASL.L	#2,D4
	SWAP	D4
	ADD.W	Y1,D4		* D4 = Yv

* Zv = Xv
	MOVE.W	D3,D5		* D5 = Zv

	BSR	PSTAT
	BCLR.B	#0,STAT2
	BRA	CLOOP

* Clip Point 1 to the Top Edge, Z=X
TE2:	MOVE.W	X2,D0
	SUB.W	X1,D0
	SUB.W	Z2,D0
	ADD.W	Z1,D0

	MOVE.W	Z1,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D0,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D0
	SUB.W	X1,D0
	MULS	D6,D0
	ASL.L	#2,D0
	SWAP	D0		
	ADD.W	X1,D0		* D0 = Xv

* Yv = (Y2-Y1)*T + Y1
	MOVE.W	Y2,D1
	SUB.W	Y1,D1
	MULS	D6,D1
	ASL.L	#2,D1
	SWAP	D1
	ADD.W	Y1,D1		* D1 = Yv

* Zv = Xv
	MOVE.W	D0,D2		* D2 = Zv

	BSR	PSTAT
	BCLR.B	#0,STAT1
	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 2 to the Bottom Edge, Z=-X
*
*	T =    -(X1+Z1)
*	    ---------------
*	    (X2-X1)+(Z2-Z1)
*
BE1:	MOVE.W	X2,D3
	SUB.W	X1,D3
	ADD.W	Z2,D3
	SUB.W	Z1,D3

	MOVE.W	Z1,D6
	NEG.W	D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D3,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D3
	SUB.W	X1,D3
	MULS	D6,D3
	ASL.L	#2,D3
	SWAP	D3		
	ADD.W	X1,D3		* D3 = Xv

* Yv = (Y2-Y1)*T + Z1
	MOVE.W	Y2,D4
	SUB.W	Y1,D4
	MULS	D6,D4
	ASL.L	#2,D4
	SWAP	D4
	ADD.W	Y1,D4		* D4 = Yv

* Zv = -Xv
	MOVE.W	D3,D5		
	NEG.W	D5		* D5 = Zv

	BSR	PSTAT
	BCLR.B	#4,STAT2
	BRA	CLOOP

* Clip Point 1 to the Bottom Edge, Z=-X
BE2:	MOVE.W	X2,D0
	SUB.W	X1,D0
	ADD.W	Z2,D0
	SUB.W	Z1,D0

	MOVE.W	Z1,D6
	NEG.W	D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D0,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D0
	SUB.W	X1,D0
	MULS	D6,D0
	ASL.L	#2,D0
	SWAP	D0		
	ADD.W	X1,D0		* D0 = Xv

* Yv = (Y2-Y1)*T + Z1
	MOVE.W	Y2,D1
	SUB.W	Y1,D1
	MULS	D6,D1
	ASL.L	#2,D1
	SWAP	D1
	ADD.W	Y1,D1		* D1 = Yv

* Zv = -Xv
	MOVE.W	D0,D2		
	NEG.W	D2		* D2 = Zv

	BSR	PSTAT
	BCLR.B	#4,STAT1
	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 2 to XMIN,   Xv = XMIN 
*
*  	T =    	XMIN-X1
*      		-------
*		(X2-X1)
*
XE1	MOVE.W	X2,D3
	SUB.W	X1,D3

	MOVE.W	XMIN,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D3,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = XMIN
	MOVE.W	XMIN,D3		* D3 = Xv

* Yv = (Y2-Y1)*T + Y1
	MOVE.W	Y2,D4
	SUB.W	Y1,D4
	MULS	D6,D4
	ASL.L	#2,D4
	SWAP	D4
	ADD.W	Y1,D4		* D4 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D5
	SUB.W	Z1,D5
	MULS	D6,D5
	ASL.L	#2,D5
	SWAP	D5
	ADD.W	Z1,D5		* D5 = Zv

	BSR	PSTAT
	BCLR.B	#5,STAT2
	BRA	CLOOP

* Clip Point 1 to XMIN,   Xv = XMIN 
XE2:	MOVE.W	X2,D0
	SUB.W	X1,D0

	MOVE.W	XMIN,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D0,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = XMIN
	MOVE.W	XMIN,D0		* D0 = Xv

* Yv = (Y2-Y1)*T + Y1
	MOVE.W	Y2,D1
	SUB.W	Y1,D1
	MULS	D6,D1
	ASL.L	#2,D1
	SWAP	D1
	ADD.W	Y1,D1		* D1 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D2
	SUB.W	Z1,D2
	MULS	D6,D2
	ASL.L	#2,D2
	SWAP	D2
	ADD.W	Z1,D2		* D2 = Zv

	BSR	PSTAT
	BCLR.B	#5,STAT1
	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Project the two points and draw a line between them
CPROJ
*Screen Y1
	SWAP	D2		* PZ1
	CLR.W	D2
	ASR.L	#2,D2
	DIVS	D0,D2		* D2 = PZ1/PX1	
	ASR.W	#5,D2		* D2 = PZ1/PX1 (scaled)	<<<<<<<<<<<<<<<<<<<<<

*Screen X1
	SWAP	D1		* PY1
	CLR.W	D1
	ASR.L	#2,D1
	DIVS	D0,D1		* D1 = PY1/PX1
	ASR.W	#5,D1		* D1 = PY1/PX1 (scaled) <<<<<<<<<<<<<<<<<<<<<

*Screen Y2
	SWAP	D5		* PZ2
	CLR.W	D5
	ASR.L	#2,D5
	DIVS	D3,D5		* D5 = PZ2/PX2	
	ASR.W	#5,D5		* D5 = PZ2/PX2 (scaled)	<<<<<<<<<<<<<<<<<<<<<

*Screen X2
	SWAP	D4		* PY2
	CLR.W	D4
	ASR.L	#2,D4
	DIVS	D3,D4		* D4 = PY2/PX2
	ASR.W	#5,D4		* D4 = PY2/PX2 (scaled) <<<<<<<<<<<<<<<<<<<<<
		
* D2 = SY1
* D1 = SX1
*
* D5 = SY2
* D4 = SX2

* Format and add to VG Buffer
	MOVE.L	VG_PTR,A0
	MOVE.W	#$7200,(A0)+
	MOVE.W	#$6280,(A0)+

*   PLOT P1
	MOVE.W	D2,D6
	AND.W	#$1FFF,D6	*dy = PY1	
	MOVE.W	D6,(A0)+

	MOVE.W	D1,D6
	AND.W	#$1FFF,D6	*dx = PX1
	MOVE.W	D6,(A0)+

*   DRAWTO P2 
	SUB.W	D2,D5
	AND.W	#$1FFF,D5	* dy = PY2-PY1
	MOVE.W	D5,(A0)+

	SUB.W	D1,D4
	AND.W	#$1FFF,D4	
	OR.W	#$6000,D4	* dx = PX2-PX1
	MOVE.W	D4,(A0)+

	MOVE.W	#$8040,(A0)+
	MOVE.L	A0,VG_PTR

	RTS

*----------------------------
PSTAT
* Form Point 1 status word
	CLR.L	D7

* Is PZ1 > PX1 ? (Above top)	  $01
	CMP.W	D0,D2
	BLE	PS1
	BSET	#0,D7

* Is PZ1 < -PX1 ? (Below bottom)  $02	
PS1	MOVE.W	D0,D6		
	NOT.W	D6
	CMP.W	D6,D2
	BGE	PS2
	BSET	#1,D7

* Is PY1 > PX1 ? (Beyond right)   $04
PS2	CMP.W	D0,D1
	BLE	PS3
	BSET	#2,D7

* Is PY1 < -PX1 ?  (Beyond Left)  $08
PS3	CMP.W	D6,D1
	BGE	PS4
	BSET	#3,D7

* Is PX1 < $100 ?  (Behind or too close)  $10
PS4	CMP.W	#$100,D0
	BGE	PS5
	BSET	#4,D7

PS5	MOVE.B	D7,STAT1	* Point 1 status word
*----------------------------
* Form Point 2 status word
	CLR.L	D7		* STAT2

* Is PZ2 > PX2 ? (Above top)	  $01
	CMP.W	D3,D5
	BLE	PS6
	BSET	#0,D7		

* Is PZ2 < -PX2 ? (Below bottom)  $02	
PS6	MOVE.W	D3,D6		
	NOT.W	D6
	CMP.W	D6,D5
	BGE	PS7
	BSET	#1,D7		

* Is PY2 > PX2 ? (Beyond right)   $04
PS7	CMP.W	D3,D4		
	BLE	PS8
	BSET	#2,D7		 

* Is PY2 < -PX2 ?  (Beyond Left)  $08
PS8	CMP.W	D6,D4		
	BGE	PS9
	BSET	#3,D7	

* Is PX2 < XMIN ?  (Behind or too close)  $10
PS9	CMP.W	XMIN,D3
	BGE	PS10
	BSET	#4,D7	

PS10	MOVE.B	D7,STAT2	* Point 2 status word

	RTS
*----------------------------
	END



