	TTL	'DUNGEONS'


	XDEF	reset
	XDEF	up,down,left,right
	XDEF	shotat,colide

	XDEF	mohor,mover,mopic,molink

	XREF	dnd
	XREF	center,draw,replace,maze

	XDEF	blink
	XDEF	cdec
	XDEF	chex
	XDEF	cnum
	XDEF	erase
	XDEF	etype
	XDEF	hscroll
	XDEF	pulse
	XDEF	type
	XDEF	vscroll
	XDEF	wnum
	XDEF	write
	XDEF	imess
	XDEF	initmess
	XDEF	delay

ANAL0	EQU	$F40000		* a/d addresses
ANAL1	EQU	$F40002
ANAL2	EQU	$F40004
ANAL3	EQU	$F40006
ANAL4	EQU	$F40008
ANAL5	EQU	$F4000A
ANAL6	EQU	$F4000C
ANAL7	EQU	$F4000E
ANALOF	EQU	$F40010		* disable analog interrupts

ANCOL0	EQU	$B00000
ANCOL1	EQU	$B00020
ANCOL2	EQU	$B00040
ANCOL3	EQU	$B00060
ANCOL4	EQU	$B00080
ANCOL5	EQU	$B000A0
ANCOL6	EQU	$B000C0
ANCOL7	EQU	$B000E0

MIDVAL	EQU	$40		* analog value to determine if switch open/close

SWITCHS	EQU	$F60000		* switch inputs D0-D3 (low true)

blink 	EQU	$100
cdec 	EQU	$106
chex 	EQU	$10C
cnum 	EQU	$112
erase 	EQU	$118
etype 	EQU	$11E
hscroll EQU	$124
pulse 	EQU	$12A
type 	EQU	$130
vscroll EQU	$136
wnum 	EQU	$13C
write 	EQU	$142
imess	EQU	$148
initmess EQU	$14E
delay	EQU	$154
imchain EQU	$401F00
imvscrl	EQU	$401F02

mopic	EQU	$402000		*motion object pictures
mohor	EQU	$402800		*motion object horizontal
mover	EQU	$403000		*motion object vertical
molink	EQU	$403800		*motion object link

wtchdg	EQU	$880000		*watchdog
irqack	EQU	$8A0000		*irq (vblank) ack
vscrol	EQU	$820000		*V scroll register
hscrol	EQU	$800000		*H scroll register


	SECTION	99

	XDEF	stick,levelno
	XDEF	sync,horiz,vert
	XDEF	plyrcolor,bmbcolor,bmbplyr,bombsw
levelno: DS.W	1		* current level number being used
stick:	DS.W	1		* stick shadow
sync:	DS.W	1		* non-zero at start of VBLANK
horiz:	DS.W	1		* horizontal shadow register
vert:	DS.W	1		* vertical shadow register
stkmsk:	DS.W	1		* stick bit indicator
stkptr:	DS.L	1		* stick analog address
plyrcolor: DS.W	4		* player colors used when player is hit
bmbcolor: DS.W	1		* bomb color used when a player hits the bomb button
bmbplyr: DS.W	1		* player number that did the bombing
bombsw:	DS.W	4		* switch debounce of bomb switches
 

	SECTION 9

	ORG	$10000
	JMP	reset		*RESET
	JMP	irq		*CINT4-vblank
	JMP	*		*CINT1
	JMP	*		*CINT3
	JMP	stkint		*CINT2-analog ADC's
	JMP	comint		*CINT6-audio processor
	JMP	trap		*CEXCP-hardare exceptions
	DC.W	0,0,0		*CALPHA
	DC.W	0,0,0		*CPLYFLD
	DC.W	0,0,0		*CMOB
	DC.W	0,0,0		*CCOLOR
	JMP	control		*CCNTL
	DC.W	0,0,0		*STATS
	DC.W	0,0,0		*EEINIT

	ORG	$10060
	DC.W	0		*playfield blank stamp
	DC.W	$10		*playfield crosshatch stamp
	DC.W	1		*playfield color 1 stamp
	DC.W	2		*playfield color 2 stamp
	DC.W	3		*playfield color 3 stamp
	DC.W	0		*starting motion object picture #
	DC.W	$3FF		*ending motion object picture #
	DC.B	0		*Model Num
	DC.B	1		*Histogram levels
	DC.W	1234		*Game options
	DC.B	0		*horizontal monitor
	DC.B	0		*no voice chip
	DC.L	0		*D0=0=bomb sw
	DC.L	0		*D1=0=fire sw
	DC.L	0		*D15=up, D14=down, D13=left, D12=right

	ORG	$10080
	DC.L	$10000
	DC.L	$1FFFF
	DC.L	$4000
	DC.L	$1
	DC.L	0
	DC.L	0


	ORG	$100EA		;dundeon editor interface definitions
	JMP	center		;center(index)=place screen center at index
	DC.L	maze		;pointer to *maze[100]
	JMP	draw		;draw(pointer) redraws the screen
	JMP	replace		;replace(index,type) replaces the type at index


	ORG	$10100		;start of program memory
trap:	CMP.W	#0,D0
	BEQ.S	*		;hang if this is a trap
*				;else there were checksum errors	
reset:	CLR.L	stkptr		;clear pointer to current joystick
	MOVE.W	#$2100,SR	;enable VBLANK, analog ADC and communications interrupt
	JMP 	dnd		;start main program

*
*	VBLANK INTERRUPT
*
	xdef	irq
irq:	MOVEM.L	D0-D1/A0-A1,-(SP)
	MOVE.W	D0,wtchdg	;stop watchdog resets
	MOVE.W	D0,irqack	;stop watchdog resets
	MOVE.W	vert,vscrol	;reset vertical scroll register
	MOVE.W	horiz,hscrol	;set horizontal scroll register
	ADDI.W	#1,sync		;signal start of frame for main loop
*				;software watchdog checks
*				;process coins
	MOVE.W	#$FF00,ANCOL7+4 ;set red line to indicate frame time
	MOVE.W	plyrcolor,ANCOL1 ;display colors if player is hit
	MOVE.W	plyrcolor+2,ANCOL2
	MOVE.W	plyrcolor+4,ANCOL3
	MOVE.W	plyrcolor+6,ANCOL4
	MOVE.W	bmbcolor,D0
	MOVE.W	D0,ANCOL0
	MOVE.W	D0,ANCOL5
	MOVE.W	D0,ANCOL6
	MOVE.W	D0,ANCOL7
	CLR.L	plyrcolor
	CLR.L	plyrcolor+4
	CLR.W	bmbcolor

	MOVE.W	SWITCHS,D0	; debounce the bomb switches
	LSR.W	#1,D0
	ROXL.W	bombsw
	LSR.W	#2,D0
	ROXL.W	bombsw+2
	LSR.W	#2,D0
	ROXL.W	bombsw+4
	LSR.W	#2,D0
	ROXL.W	bombsw+6

	TST.L	stkptr		; JOYSTICK read necessary ??
	BNE.S	Lnostk		; analog reading is still pending
	JSR	joystrt		; start up joystick conversions
Lnostk:
	MOVEM.L	(SP)+,D0-D1/A0-A1 ;restore registers
	RTE

*
*	COMMUNICATIONS INTERRUPT
*
comint:	
	RTE


*
*	SELF TEST CONTROLS
*
control: MOVE.L	D2,-(SP)
	MOVE.W	SR,D2		; save old status register interrupt level
	MOVE.W 	#$2100,SR	; enable interrupts
	JSR	joystrt		; start joystick conversions
Loop:	TST.L	stkptr
	BNE.S	Loop		; wait for all conversions to complete
	MOVE.W	D2,SR		; restore status level
	MOVE.W	stick,D0	; give self test our inputs
	MOVE.L	(SP)+,D2
	RTS


joystrt: MOVE.L	#ANAL0,A0
	TST.W	(A0)+		; start a conversion
	MOVE.L	A0,stkptr	; save new "stkptr"
	CLR.W	stkmsk
	MOVE.W	SWITCHS,D0
	MOVE.B	D0,stick+1	; set switch inputs into shadow RAM too
	RTS


*
*	JOYSTICK READER - This routine will read the joysticks
*		and update the value in "stick".
*
stkint:	MOVEM.L	D0/D1/A0,-(SP)
	MOVE.W	stkmsk,D0
	LEA.L	Lmsk,A0
	MOVE.B	0(A0,D0.W),D0	; get mask bit for this joystick
	ADDI.W	#1,stkmsk	; setup next mask
	MOVE.L	stkptr,A0	; point to next port to read
	MOVE.W	(A0)+,D1
	AND.W	#$0FF,D1	; make positive
	CMP.W	#MIDVAL,D1
	BLT.S	Llow
	BSET.W	D0,stick	; HIGH (switch open)
	BRA.S	Lboth

Llow:
	BCLR.W	D0,stick	; LOW (switch closed)
Lboth:
	CMPA.L	#ANAL7+4,A0	; converted all ?
	BLT.S	Lexit		; we have not done 8 conversions
	SUBA.L	A0,A0		; clear A0
	TST.W	ANALOF
Lexit:
	MOVE.L	A0,stkptr
	MOVEM.L	(SP)+,D0/D1/A0
	RTE

Lmsk:	DC.B	12,14,15,13	; player 1 joystick
	DC.B	8,10,11,9	; player 2 joystick
 

	PAGE
*	This routine is the 68000 assembly language version of a
*	random number routine based on the "linear congruential"
*	algorithm discussed in Knuth's "Art of Computer Programming"
*	The constants A and C were chosen to allow the
*	truncation to 16 bits to provide the "modulo" operation
*	required by the function. The routine therefore assumes
*	that a short is 16 bits and a long is 32. If this isn't
*	true for you, you need to read Knuth and pick your
*	own constants. Note that the routine uses two "short"
*	multiplies, and no divides, so should be quick.

*		rands(in,seed)					*/
*	Returns a random number between 0 and in. Seed is a	*/
*	pointer to the seed, which should be global or static	*/
*	to the caller, to avoid	repeating the same "random"	*/
*	number. This use of an external seed allows you to	*/
*	re-initialize the sequence or have multiple independant	*/
*	sequences. If neither is needed, call rand(in), below	*/

A	EQU	23861
C	EQU	13849
	SECTION	9
*	short rands(in,seed)
*	short in,*seed;			in=D0, *seed = A0
*	{
*	unsigned long lfrac;		D0
	xdef	rands
rands:
	MOVE.L	8(SP),A0
RANDSD:	MOVE.L	4(SP),D1
	MOVE.W	(A0),D0
*	    *seed = ((*seed * C + A) & 0xffff);
	MULS	#C,D0
	ADD.W	#A,D0
	MOVE.W	D0,(A0)

*	    lfrac = in * *seed;
	MULS	D1,D0

*	    return( (((long) in << 15) + lfrac) >> 16);
	SWAP	D1
	MOVE.W	#0,D1
	ASR.L	#1,D1		((long) in << 15)
	ADD.L	D1,D0		+ lfrac
	SWAP	D0		>> 16
	EXT.L	D0
	RTS
*	};

*		rand(in)					*/
*	Returns a random number between 0 and in. Seed is	*/
*	kept locally, in a static variable, so need not be 	*/
*	provided. On the other hand, multiple uses of rand(in)	*/
*	will not be truly independant, nor can the sequence	*/
*	be restarted. For these features, see rands(in,seed)	*/

*	short rand(in)
*	short in;
*	{
*	static short seed;
	SECTION	14
SEED:	DS.W	1

	SECTION	9
	xdef	rand

*	    return(rands(in,&seed));
rand:	LEA	SEED,A0
	BRA.S	RANDSD
*	};

	PAGE
SZMO	EQU	2
*
*	up(I,SIZE)		- C callable routine
*
*ENTRY	(I)=POINTER TO mohor ENTRY OF OBJECT TO BE MOVED
*	(SIZE)=COLLISION SIZE
*EXIT	(D0)=INDEX OF COLLISION ENTRY ELSE -1 IF NO COLLISION 
*USES	D0, D1, A0, A1
up:	MOVEA.L	4(A7),A1	;GET POINTER TO OBJECT TABLE
	LEA.L	mover-mohor(A1),A0
	CMPA.L	#mohor+SZMO*63,A1
	BHI.S	up0		;NOT ON THE TOP ROW
	MOVE.W	(A0),D0
	CMP.W	#(512-32)*$80,D0
	BLS.S	up3x		;NO COLLISION DETECTION - NOTHING ABOVE US
	MOVE.L	#0,D0		;WE RUN INTO A WALL ABOVE US
	RTS

up0:	MOVEM.L	D2/A2,-(SP)
	LEA.L	mopic-mohor(A1),A2
	MOVE.W	18(A7),D2	;SET COLLISION SIZE
	MOVE.W	#-32*SZMO,D1	;ENTRY TO CHECK
	BSR.L	colide		;CHECK FOR COLISION
	BCS.S	up4		;COLISION OCCURED
up1:	MOVE.W	#-33*SZMO,D1	;ENTRY TO CHECK
	BSR.L	colide		;CHECK FOR COLISION
	BCS.S	up4		;COLISION OCCURED
up2:	MOVE.W	#-31*SZMO,D1	;ENTRY TO CHECK
	BSR.S	colide		;CHECK FOR COLISION
	BCS.S	up4		;COLISION OCCURED
up3:	MOVEM.L (SP)+,D2/A2
up3x:	MOVE.L	#-1,D0		;RETURN NO COLLSION INDICATION
	RTS

up4:	ADDA.W	D1,A1
	ADDA.L	#-mohor,A1
	MOVE.L	A1,D0		;2*INDEX OF COLLISION ENTRY
	LSR.W	#1,D0
	MOVEM.L (SP)+,D2/A2
	RTS


*
*	down(I,SIZE)		- C callable routine
*
*ENTRY	(I)=POINTER TO mohor ENTRY OF OBJECT TO BE MOVED
*	(SIZE)=COLLISION SIZE
*EXIT	(D0)=INDEX OF COLLISION ENTRY ELSE -1 IF NO COLLISION 
*USES	D0, D1, A0, A1
down:	MOVEA.L	4(A7),A1	;GET POINTER TO OBJECT TABLE
	LEA.L	mover-mohor(A1),A0
	MOVE.W	#33*SZMO,D1	;ENTRY TO CHECK
	CMPA.L	#mohor+SZMO*(1024-33),A1
	BLS.S	down0		;NOT ON THE BOTOM ROW
	MOVE.W	(A0),D0
	BPL.S	down3x		;NO COLLISION DETECTION - NOTHING BELOW US
	MOVE.L	#0,D0		;WE RUN INTO A WALL BELOW US
	RTS

down0:	BNE.S	down0x		;BEWARE OF THE NEXT TO LAST ROW AND LAST ENTRY
	MOVE.W	#1*SZMO,D1	;USE THIS WALL ENTRY TO CHECK
down0x:	MOVEM.L	D2/A2,-(SP)
	LEA.L	mopic-mohor(A1),A2
	MOVE.W	18(A7),D2	;SET COLLISION SIZE
	BSR.S	colide		;CHECK FOR COLISION
	BCS.S	down4		;COLISION OCCURED
down1:	MOVE.W	#32*SZMO,D1	;ENTRY TO CHECK
	BSR.S	colide		;CHECK FOR COLISION
	BCS.S	down4		;COLISION OCCURED
down2:	MOVE.W	#31*SZMO,D1	;ENTRY TO CHECK
	BSR.S	colide		;CHECK FOR COLISION
	BCS.S	down4		;COLISION OCCURED
down3:	MOVEM.L (SP)+,D2/A2
down3x:	MOVE.L	#-1,D0		;RETURN NO COLLSION INDICATION
	RTS

down4:	ADDA.W	D1,A1
	ADDA.L	#-mohor,A1
	MOVE.L	A1,D0		;2*INDEX OF COLLISION ENTRY
	LSR.W	#1,D0
	MOVEM.L (SP)+,D2/A2
	RTS


*
*	COLISION IF ABS(H(X)-H(I))<D0 and
*		    ABS(V(X)-V(I))<D0
*
*	OBJECT ENTRY LOOKS LIKE:
*		PICTURE.W
*		H.W
*		V.W
*		LINK
*
*	FOR THE COLLISION SIZE BE CAREFUL THAT THE LOWER BITS DO NOT EFFECT THE
*	RESULTS.  FOR EXAMPLE SEE BELOW. 
*		6800-603F=7C1 NO COLLISION
*		67BF-6000=7BF COLLISION
*		683F-6000=83F NO COLLISION
*		6780-603F=741 COLLISION
*		6000-683F=-83F NO COLLISION
*		60BF-6800=-741 COLLISION
*		603F-6800=-7C1 NO COLLSION
*		6080-683F=-7BF COLLISION
*
**** 	WE HAVE ASSUMED THAT D6 MUST NOT BE USED IN H,V COMPARISONS.
*
*ENTRY	(D1)=OFFSET OF ENTRY TO CHECK
*	(D2)=SIZE OF COLLISION WINDOW
*	(A0)=ADDRESS OF mover[index]
*	(A1)=ADDRESS OF mohor[index]
*	(A2)=ADDRESS OF mopic[index]
*EXIT	(CC)=CS IF COLLISION OCCURED
*USES	D0
colide:	TST.W	0(A2,D1)
	BEQ.S	colid3		;THERE IS NO ENTRY TO COLIDE WITH (CARRY CLEAR)
	MOVE.W	(A1),D0		;H(I)
	SUB.W	0(A1,D1.W),D0	;H(I)-H(X)
	BPL.S	colid1		;ABS
	NEG.W	D0
colid1:	CMP.W	D2,D0
	BCC.S	colid3		;NO POSSIBLE COLLISION
	MOVE.W	(A0),D0		;V(I)
	SUB.W	0(A0,D1.W),D0	;V(I)-V(X)
	BPL.S	colid2		;ABS
	NEG.W	D0
colid2:	CMP.W	D2,D0
colid3:	RTS			;RETURN COLLISION STATUS


*
*	left(I,SIZE)		- C callable routine
*
*ENTRY	(I)=POINTER TO mohor ENTRY OF OBJECT TO BE MOVED
*	(SIZE)=COLLISION SIZE
*EXIT	(D0)=INDEX OF COLLISION ENTRY ELSE -1 IF NO COLLISION 
*USES	D0, D1, A0, A1
left:	MOVEA.L	4(A7),A1	;GET POINTER TO OBJECT TABLE
	MOVEM.L	D2/A2,-(SP)
	LEA.L	mopic-mohor(A1),A2
	LEA.L	mover-mohor(A1),A0
	MOVE.W	18(A7),D2	;SET COLLISION SIZE
	MOVE.W	#-1*SZMO,D1	;ENTRY TO CHECK
	BSR.S	colide		;CHECK FOR COLISION
	BCS.S	left4		;COLISION OCCURED
left1:	CMPA.L	#mohor+SZMO*64,A1
	BLS.S	left3		;NO COLLISION CHECK NEEDED IF ON TOP ROW
	MOVE.W	#-33*SZMO,D1	;ENTRY TO CHECK
	BSR.S	colide		;CHECK FOR COLISION
	BCS.S	left4		;COLISION OCCURED
left2:	CMPA.L	#mohor+SZMO*(1024-32),A1
	BHI.S	left3		;NO COLLISION CHECK NEEDED IF ON BOTTOM ROW
	MOVE.W	#31*SZMO,D1	;ENTRY TO CHECK
	BSR.S	colide		;CHECK FOR COLISION
	BCS.S	left4		;COLISION OCCURED
left3:	MOVE.L	#-1,D0		;RETURN NO COLLSION INDICATION
	MOVEM.L (SP)+,D2/A2
	RTS

left4:	ADDA.W	D1,A1
	ADDA.L	#-mohor,A1
	MOVE.L	A1,D0		;2*INDEX OF COLLISION ENTRY
	LSR.W	#1,D0
	MOVEM.L (SP)+,D2/A2
	RTS


*
*	right(I,SIZE)		- C callable routine
*
*ENTRY	(I)=POINTER TO mohor ENTRY OF OBJECT TO BE MOVED
*	(SIZE)=COLLISION SIZE
*EXIT	(D0)=INDEX OF COLLISION ENTRY ELSE -1 IF NO COLLISION 
*USES	D0, D1, A0, A1
right:	MOVEA.L	4(A7),A1	;GET POINTER TO OBJECT TABLE
	MOVEM.L	D2/A2,-(SP)
	LEA.L	mopic-mohor(A1),A2
	LEA.L	mover-mohor(A1),A0
	MOVE.W	18(A7),D2	;SET COLLISION SIZE
	MOVE.W	#1*SZMO,D1	;ENTRY TO CHECK
	BSR.L	colide		;CHECK FOR COLISION
	BCS.S	right4		;COLISION OCCURED
right1:	CMPA.L	#mohor+SZMO*64,A1
	BLS.S	left3		;NO COLLISION CHECK NEEDED IF ON TOP ROW
	MOVE.W	#-31*SZMO,D1	;ENTRY TO CHECK
	BSR.L	colide		;CHECK FOR COLISION
	BCS.S	right4		;COLISION OCCURED
right2:	CMPA.L	#mohor+SZMO*(1024-34),A1
	BLS.S	right3		;NO COLLISION IF ON BOTTOM ROW OR LOWER RIGHT CORNER
	MOVE.W	#33*SZMO,D1	;ENTRY TO CHECK
	BSR.L	colide		;CHECK FOR COLISION
	BCS.S	right4		;COLISION OCCURED
right3:	MOVE.L	#-1,D0		;RETURN NO COLLSION INDICATION
	MOVEM.L (SP)+,D2/A2
	RTS

right4:	ADDA.W	D1,A1
	ADDA.L	#-mohor,A1
	MOVE.L	A1,D0		;2*INDEX OF COLLISION ENTRY
	LSR.W	#1,D0
	MOVEM.L (SP)+,D2/A2
	RTS


*
*	shotat(I,SIZE)		- C callable routine
*
*ENTRY	(I)=POINTER TO mohor ENTRY OF OBJECT TO BE CHECKED
*	(SIZE)=COLLISION SIZE
*EXIT	(D0)=0 IF COLLISION OCCURED ELSE -1 
*USES	D0, D1, A0, A1
shotat:	MOVEA.L	4(A7),A1	;GET POINTER TO OBJECT TABLE
	MOVEM.L	D2/A2,-(SP)
	LEA.L	mopic-mohor(A1),A2
	LEA.L	mover-mohor(A1),A0
	MOVE.W	10(A7),D2	;SET COLLISION SIZE
	MOVE.W	#0,D1		;ENTRY TO CHECK
	BSR.L	colide		;CHECK FOR COLISION
	BCS.S	shotat4		;COLISION OCCURED
	MOVE.L	#-1,D0		;RETURN NO COLLSION INDICATION
	MOVEM.L (SP)+,D2/A2
	RTS

shotat4: MOVEM.L (SP)+,D2/A2
	MOVE.L	#0,D0		;RETURN COLLISION INDICATION
	RTS


	END

