	TTL 'MAIN'
	
	XREF INITUV,POST1,POST2,ROLL,PITCH,YAW,CONCAT,PRESUB,TPROJ
	XREF TANK,CUBE,ROCKET,AIR,SAUCER,BUZZ,FLM,SQ,BOX,TSQ,HIND
	XREF VGHALT,CENTER
	XREF D_CUBE,D_SQ,D_TANK,D_ROC,D_AIR,D_SAU,D_BUZZ,D_HIND
*	XREF VGOVER,HEADUP,HEADING,ALTITUDE,AIRSPEED,VWTHRUST,HORIZ
*	XREF VWHEX,AERO,VWBYTE,VWWORD

	INCLUDE 'COMN2.ASM'
	INCLUDE	'EQUATES.ASM'

	XDEF VGGO,VGRES,WDCLR,IRQCLR
	XDEF VGDATA
	XDEF TEST1,TEST2,TEST3,TEST4,TEST5,TEST6,TEST7,TEST8,TEST9,TEST10
	XDEF VG1,VG2,VG3,VG4,VG5,VG6,VG7
	XDEF POTS,SW

	XDEF MULT1,MULT2,ANS,PXP,PYP,PZP,SX,SY

	ORG $2400
* RAM
MULT1	DC.W	$4000
MULT2	DC.W	$4000
ANS	DS.W	1
PXP	DC.L	$10000000
PYP	DC.L	$10000000
PZP	DC.L	$10000000
SX	DS.W	1
SY	DS.W	1

	PAGE
	ORG $4000
	
* VG ADDRESSES (TO BE MODIFIED BY POTS)
*
VGADR1	EQU 	VMEM+$001F	*Y OF POINT	
VGADR2	EQU	VMEM+$0021	*X OF POINT
VGADR3	EQU	VMEM+$0001	*LINEAR SCALE
VGADR4	EQU	VMEM+$0003	*ZSTAT BRIGHTNESS

* VG DATA FOR STAR TV
VGDATA	DC.W $7180			*SCALE BIN=1,LIN=80
	DC.W $6780			*COLOR WHT,ZSTAT=80
	DC.W $8040			*CENTER
	DC.W $0100,$6100 		*VECTOR 
	DC.W $8040 			*CENTER
	DC.W $0100,$7F00		*VECTOR
	DC.W $8040			*CENTER (2010)
	DC.W $0000,$6120 		*VECTOR
	DC.W $8040			*CENTER
	DC.W $0000,$7EF0 		*VECTOR
	DC.W $8040 			*CENTER
	DC.W $1E91,$6023 		*VECTOR (201E)
	DC.W $8040 			*CENTER
	DC.W $01F0,$6000		*VECTOR
	DC.W $8040			*CENTER
	DC.W $01A0,$60A0		*VECTOR
	DC.W $8040			*CENTER
	DC.W $0180,$7F67		*VECTOR
	DC.W $8040			*CENTER
	DC.W $2000			*HALT

	PAGE
* DATA LINES WALKING ONES @VMEM
TEST1	MOVE.L	#$3000,A7
	LEA	VMEM,A0			
	MOVE.L	#1,D0
T1LP	
	MOVE.W	D0,(A0)
	ROL.W	#1,D0
	BRA	T1LP	

* ADDRESS LINES 1-8 WALKING ONES @VMEM
TEST2	MOVE.L	#$3000,A7
	MOVE.W	#$5555,D0
	LEA	VMEM,A0
	MOVE.B	#1,D1
T2LP	
	MOVE.B	D1,A0
	MOVE.W	D0,(A0)

	ROL.B	#1,D1
	BRA 	T2LP	

* Projection 1		SX=K*YP/XP, SY=K*ZP/XP
TEST3	MOVE.L	#$3000,A7
	
T3	MOVE.B	D0,LED1ON	*Timing Mark on

	MOVE.L	PXP,D0		*D0 = 1000 0000   (PXP from MACC)
	ASR.L  	#8,D0
	ASR.L  	#6,D0	 	*D0 = 4000
	MOVE.L	PYP,D1		*D1 = 1000 0000   (PYP from MACC))
	DIVS  	D0,D1	 	*D1 = D1/D0 = 4000 is too big
	ASR.W  	#5,D1		*D1 = 200 (VG will normalise it to 100)
	MOVE.W	D1,SX
*	(D0 = 4000)
	MOVE.L	PZP,D2		*D2 = 1000 0000   (PZP from MACC))
	DIVS  	D0,D2	 	*D2 = D2/D0 = 4000 is too big
	ASR.W  	#5,D2		*D2 = 200 (VG will normalise it to 100)
	MOVE.W	D2,SY

	MOVE.B	D0,LED1OFF	*Timing Mark off
	BRA	T3

* Projection 2		SX=K*YP/XP, SY=K*ZP/XP
TEST4	MOVE.L	#$3000,A7
	
T4	MOVE.B	D0,LED1ON	*Timing Mark on

	MOVE.L	PXP,D0		*D0 = 1000 0000   (PXP from MACC)
	ASL.L 	#2,D0
	SWAP 	D0
	MOVE.L	PYP,D1		*D1 = 1000 0000   (PYP from MACC))
	DIVS  	D0,D1	 	*D1 = D1/D0 = 4000 is too big
	ASR.W  	#5,D1		*D1 = 200 (VG will normalise it to 100)
	MOVE.W	D1,SX
*	(D0 = 4000)
	MOVE.L	PZP,D2		*D2 = 1000 0000   (PZP from MACC))
	DIVS  	D0,D2	 	*D2 = D2/D0 = 4000 is too big
	ASR.W  	#5,D2		*D2 = 200 (VG will normalise it to 100)
	MOVE.W	D2,SY

	MOVE.B	D0,LED1OFF	*Timing Mark off
	BRA	T4

* Projection 3
* Inverse Multiplies  	SX=(K/XP)*YP, SY=(K/XP)*ZP 
* (Scaling needs work, but it is close enough for timing comparison.)
TEST5	MOVE.L	#$3000,A7
	
T5	MOVE.B	D0,LED1ON	*Timing Mark on

	MOVE.L  #$800000,D1
	MOVE.L	PXP,D0		*D0 = 1000 0000   (PXP from MACC)
	ASR.L  	#8,D0
	ASR.L  	#6,D0	 	*D0 = 4000
	DIVS	D0,D1		*D1=80 0000/PXP    D1=200

*	(D1=1/PXP)

	MOVE.L	PYP,D2		*PYP=1000 0000
	SWAP	D2		*D2=1000
	MULS.W	D1,D2		*D2=D1*D2  = 200*1000 = 20 0000
	ASL.L	#3,D2		*D2 = 100 0000
	SWAP	D2		*D2=100
	MOVE.W	D2,SX		*

	MOVE.L	PZP,D2		*PZP=1000 0000
	SWAP	D2		*D2=1000
	MULS.W	D1,D2		*D2=D1*D2  = 200*1000 = 20 0000
	ASL.L	#3,D2		*D2 = 100 0000
	SWAP	D2		*D2=100
	MOVE.W	D2,SY		*

	MOVE.B	D0,LED1OFF	*Timing Mark off
	BRA	T5

* Projection 4
* Inverse Multiplies	SX=(K/XP)*YP, SY=(K/XP)*ZP
* (Scaling needs work, but it is close enough for timing comparison.)
TEST6	MOVE.L	#$3000,A7
	
T6	MOVE.B	D0,LED1ON	*Timing Mark on

	MOVE.L  #$800000,D1
	MOVE.L	PXP,D0		*D0 = 1000 0000   (PXP from MACC)
	ASR.L  	#8,D0
	ASR.L  	#6,D0	 	*D0 = 4000
	DIVU	D0,D1		*D1=80 0000/PXP    D1=200

*	(D1=1/PXP)

	MOVE.L	PYP,D2		*PYP=1000 0000
	SWAP	D2		*D2=1000
	MULS.W	D1,D2		*D2=D1*D2  = 200*1000 = 20 0000
	ASL.L	#3,D2		*D2 = 100 0000
	SWAP	D2		*D2=100
	MOVE.W	D2,SX		*

	MOVE.L	PZP,D2		*PZP=1000 0000
	SWAP	D2		*D2=1000
	MULS.W	D1,D2		*D2=D1*D2  = 200*1000 = 20 0000
	ASL.L	#3,D2		*D2 = 100 0000
	SWAP	D2		*D2=100
	MOVE.W	D2,SY		*

	MOVE.B	D0,LED1OFF	*Timing Mark off
	BRA	T6

* WRITE TO VECTOR MEMORY
TEST7	MOVE.L 	#VMEM,A5
	MOVE.W	#$5555,(A5)
	BRA	TEST7

* WRITE TO VECTOR MEMORY
TEST8	MOVE.L 	#VMEM,A5
	MOVE.W	#$AAAA,(A5)
	BRA	TEST8

* LED Test
TEST9	MOVE.L	#$3000,A7
T9	MOVE.B	D0,LED1ON
	BSR 	WAIT
	MOVE.B	D0,LED1OFF
	MOVE.B	D0,LED2ON
	BSR 	WAIT
	MOVE.B	D0,LED2OFF
	MOVE.B	D0,LED3ON
	BSR	WAIT
	MOVE.B	D0,LED3OFF
	BRA	T9

WAIT	MOVE.L	#-65536,D0
WLP	ADDQ.L	#1,D0
	BNE	WLP
	RTS

WAIT2	MOVE.L	#-$1000,D0
W2LP	ADDQ.L	#1,D0
	BNE	W2LP
	RTS

*Test LED addressing
TEST10	MOVE.B	D0,LED1ON
	MOVE.B 	D0,LED1OFF
	BRA	TEST10

*Get the VG to work (Uses software timer instead of waiting for the Halt flag).
VG1	MOVE.L	#$3000,A7
VG1LP	JSR	AVGRES		*Reset VG
	JSR	UP		*Upload Data
	JSR	VGON		*Start VG
	JSR	WAIT2		*Wait for VG to finish drawing (Timer)
	BRA	VG1LP

*Use the VG Halt Flag.
VG2	MOVE.L	#$3000,A7
VG2LP	JSR	AVGRES		*Reset VG
	JSR	UP		*Upload Data
	JSR	VGON		*Start VG
	JSR	VGWAIT		*Wait for VG to finish drawing (VG Flag)
	BRA	VG2LP

* In the loop, restart the VG instead of reloading from scratch.
VG3	MOVE.L	#$3000,A7
	JSR	AVGRES		*Reset VG
	JSR	UP		*Upload Data
VG3LP	JSR	VGON		*Start VG
	JSR	VGWAIT		*Wait for VG to finish drawing
	BRA	VG3LP

* Run the VG and Read the Pots (But don't do anything with the results).
VG4	MOVE.L	#$3000,A7
	JSR	AVGRES		*Reset VG
	JSR	UP		*Upload Data
VG4LP	JSR	VGON		*Start VG
	JSR	VGWAIT		*Wait for VG to finish drawing
	JSR	POTS		*Read the Pots
	BRA	VG4LP

* Run the VG, Read the Pots and switches, and modify the VG Data as required.
VG5	MOVE.L	#$3000,A7
	JSR	AVGRES		*Reset VG
	JSR	UP		*Upload Data
VG5LP	JSR	VGON		*Start VG
	JSR	VGWAIT		*Wait for VG to finish drawing
	JSR	POTS		*Read the Pots
	JSR	SW		*Read the switches and modify the VG data as 
*				 required
	BRA	VG5LP

* Similar to #5 but reads the pots while the VG is going.
VG6	MOVE.L	#$3000,A7
	JSR	AVGRES		*Reset VG
	JSR	UP		*Upload Data
VG6LP	JSR	VGON		*Start VG
	JSR	POTS		*Read the Pots
	JSR	VGWAIT		*Wait for VG to finish drawing
	JSR	SW		*Read the switches and modify the VG data as 
*				 required
	BRA	VG6LP

* Wait for VGHALT but do VG reads while waiting (to test the memory contention
* circuit).
VG7	MOVE.L	#$3000,A7
	JSR	AVGRES		*Reset VG
	JSR	UP		*Upload Data
VG7LP	JSR	VGON		*Start VG
	JSR	POTS		*Read the Pots
	JSR	VGWAIT2		*Wait for VG to finish drawing
	JSR	SW		*Read the switches and modify the VG data as 
*				 required
	BRA	VG7LP
	


* RESET VG
AVGRES	MOVE.B	D0,VGRES		*(Dummy Data)
	RTS

* START VG
VGON	MOVE.B	D0,VGGO			*(Dummy Data)
	RTS

* Upload VG Data (A0) to VG (A1), D0 = counter	(30 words)
UP	LEA	VGDATA,A0			
	MOVE.L	#VMEM,A1
	MOVE.B	#30,D0
UP10	MOVE.W	(A0)+,(A1)+
	ADDQ.B	#2,D0
	BNE	UP10
	RTS

* Wait for VGHALT
VGWAIT	BTST.B	#$00,INPUTS	
	BEQ	VGWAIT
	RTS

* Wait for VGHALT but do VG reads while waiting (to test the memory contention
* circuit).
VGWAIT2	
	MOVE.W	VMEM,D0
	BTST.B	#$00,INPUTS	
	BEQ	VGWAIT2
	RTS

* READ THE POTS
POTS	MOVE.B	#$0,ADCON+1		*CHANNEL 0
	MOVE.B	#$8,ADCON+1		*ALE HIGH
	MOVE.B	#10,D0			*WAIT A LITTLE
P10	SUBQ.B	#1,D0
	BNE	P10
	MOVE.B	#$0,ADCON+1		*ALE LOW

	MOVE.B	#-40,D0
P20	ADDQ.B	#1,D0			*WAIT
	BNE 	P20	

	MOVE.B	ADCREAD+1,POT0		*READ AND STORE POT 0

	MOVE.B	#1,ADCON+1		*CHANNEL 1
	MOVE.B	#$9,ADCON+1		*ALE HIGH
	MOVE.B	#10,D0			*WAIT A LITTLE
P30	SUBQ.B	#1,D0
	BNE	P30
	MOVE.B	#1,ADCON+1		*ALE LOW

	MOVE.B	#-40,D0
P40	ADDQ.B	#1,D0			*WAIT
	BNE 	P40	

	MOVE.B	ADCREAD+1,POT1		*READ AND STORE POT 0

	RTS

* Read the Switches, modify the VG data as required
SW	MOVE.B	INPUTS,D0		* D0 CONTAINS SWITCH INPUTS

	BTST.B	#5,D0
	BNE 	SLP1
	MOVE.B 	POT0,VGADR1		*LEFT TRIGGER (CHANGE POSITION)
	MOVE.B	POT1,VGADR2

SLP1	BTST.B	#4,D0
	BNE	SLP2		
	MOVE.B	POT0,VGADR3		*RIGHT TRIGGER (LINEAR SCALE)
	MOVE.B	POT1,VGADR4		*	       (INTENSITY)

SLP2	RTS


	END

